VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsDBF"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Compare Text
Option Explicit

'     DBF  (//
' /)  VB/VBA  Win API.
'   Access2000/2002  VB5/6.    
' Enum       (Property Get)
'     Access97.
' 2.0   2003 .
'  , ., .

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)

'Public Enum enDBFType
'  conDBFType_dBASE_III = &H83       'dBASE III+ with memo
'  conDBFType_dBASE_IV_V = &H8B      'dBASE IV/V with memo
'  conDBFType_FoxPro2x = &HF5        'FoxPro 2.x (or earlier) with memo
'  conDBFType_FoxPro30 = &H30        'FoxPro 3.x (Visual FoxPro)
'  conDBFType_ImpExpSpec = &H77      '    
'End Enum
  Private Const conDBFType_SimpleNoMemo As Long = &H3      'No memo

Private Type DBFHeader
    Type As Byte                  '0       
    Dat(0 To 2) As Byte           '1-3      YYMMDD
    RecordCount As Long           '4-7    - ,  
    Offset As Integer             '8-9     1- 
    RecordLength(0 To 3) As Byte  '10-13    (12,13 - )
    res(0 To 13) As Byte          '14-27
    Flag As Byte                  '28       FP(02- Memo )
    CodePage As Byte              '29        FP
    res2(0 To 1) As Byte          '30-31
End Type

Private Type DBFField
    FieldName(0 To 10) As Byte    '0-10     ( )
    Type As Byte                  '11      : "C", "N", "D"  ..
    Offset As Long                '12-15      ( )
    Length As Byte                '16      
    DecimalPlaces As Byte         '17       
    Flags As Byte                 '18     2- Null, 4-
    res(0 To 12) As Byte          '19-32
End Type

Private Type DBFFieldExt
    FieldName As String           '  ( ANSI)
    TypeDBF As Byte               '  ()
    TypeDAO As Long               '  ( DAO )
    Offset As Long                '    
    Size As Long                  '  
    Binary As Boolean             '    (""  ""  FP30)
End Type

'Public Enum enDBFCharsetMode      '  
'    DBFCharsetDOS866 = 1
'    DBFCharsetUkrStandard = 2
'    DBFCharsetANSI = 3
'End Enum
Private lngCharset As Long        '   DBF

Private hFile As Integer                ' 
Private hMemoFile As Integer            ' MEMO 
Private Head As DBFHeader               '
Private DBFFields() As DBFField         ' 
Private DBFFieldsExt() As DBFFieldExt   '   VBA
Private lngRecordLen As Long            ' 
Private lngFieldsCount As Long          ' 
Private CurRec As Long                  '  ()

Private CurData() As Byte         '  
Private BuffData() As Byte        '  

Private strDBFFullPath As String  '  DBF 
Private strMemoFullPath As String '  DBT (FPT)  (MEMO )
Private strFolder As String       '  

Private fNewFile As Boolean       '  
Private fRO As Boolean            '    
Private bytRecordMode As Byte     '1-, 2-

'=======   ==================================
Private Const conFieldTypeString As Byte = 67   '"C"
Private Const conFieldTypeNumeric As Byte = 78  '"N"
Private Const conFieldTypeDate As Byte = 68     '"D"
Private Const conFieldTypeLogical As Byte = 76  '"L"
Private Const conFieldTypeMemo As Byte = 77     '"M"
Private Const conFieldTypeGeneral As Byte = 71  '"G"
' Visual FoxPro (ver 3.0)
Private Const conFieldTypeLong As Byte = 73     '"I"
Private Const conFieldTypeDouble As Byte = 66   '"B"
Private Const conFieldTypeCurrency As Byte = 89 '"Y"
Private Const conFieldTypeDateTime As Byte = 84 '"T"
' .  /
Private Const conFieldTypeByte As Byte = 49     '"1"
Private Const conFieldTypeInteger As Byte = 50  '"2"
Private Const conFieldTypeSingle As Byte = 52   '"4"
Private Const conFieldTypeVariant As Byte = 86  '"V"
'----------------------------------------------------
Private Const daoTypeBoolean As Integer = 1     'dbBoolean
Private Const daoTypeByte As Integer = 2        'dbByte
Private Const daoTypeInteger As Integer = 3     'dbInteger
Private Const daoTypeLong As Integer = 4        'dbLong
Private Const daoTypeCurrency As Integer = 5    'dbCurrency
Private Const daoTypeSingle As Integer = 6      'dbSingle
Private Const daoTypeDouble As Integer = 7      'dbDouble
Private Const daoTypeDate As Integer = 8        'dbDate
Private Const daoTypeText As Integer = 10       'dbText
Private Const daoTypeLongBinary As Integer = 11 'dbLongBinary
Private Const daoTypeMemo As Integer = 12       'dbMemo
Private Const daoTypeDecimal As Integer = 20    'dbDecimal
'   
Private Const daoTypeBinary As Integer = 9      'dbBinary

'----------------------------------------------------
Private Const conDeleteMark As Byte = 42        '"*"
Private Const conHeaderTerminator As Byte = &HD
Private Const conFileTerminator As Byte = &H1A

Private Const conDateOffset As Long = &H24D9AB

Public Function OpenFile(strFilePath As String, _
        Optional ByVal lngCharsetForString As Long, _
        Optional fReadOnly As Boolean) As Boolean
On Error GoTo OpenFile_err
Dim i As Long
    
    strDBFFullPath = Trim$(strFilePath)
 If Len(strDBFFullPath) = 0 Then
    MsgBox "    !", vbExclamation
    Exit Function
 End If
 If Not CheckFileExists(strDBFFullPath, strFolder) Then
    MsgBox " " & strDBFFullPath & "  !", vbExclamation
    Exit Function
 End If
 If Not fReadOnly Then
    fRO = (GetAttr(strDBFFullPath) And vbReadOnly)
  If fRO Then
   If MsgBox(" " & strDBFFullPath & "   "" " _
        & " """ & vbCrLf & vbCrLf & "?", _
        vbQuestion + vbOKCancel) = vbCancel Then
    Exit Function
   End If
  End If
 Else
    fRO = True
 End If
     
 If hFile <> 0 Then Close #hFile
    
    hFile = FreeFile
 If fRO Then
    Open strDBFFullPath For Binary Access Read As hFile
 Else
    Open strDBFFullPath For Binary Access Read Write As hFile
 End If
    Get hFile, , Head
 
 Select Case GetFileType
  Case 0
    MsgBox "  " & strFilePath & "  !", vbExclamation
    Close #hFile
    hFile = 0
    Exit Function
  Case xDBFType_FoxPro30
'    Visual FoxPro
    lngFieldsCount = (Head.Offset - 296) / 32
  Case Else
'    DbaseIII-V, FoxBase, FoxPro2.x
    lngFieldsCount = (Head.Offset - 33) / 32
 End Select
    
    ReDim DBFFields(0 To lngFieldsCount - 1)
 For i = 0 To lngFieldsCount - 1
    Get hFile, , DBFFields(i)
 Next i
    Get hFile, , bytRecordMode
 If bytRecordMode <> 13 Then
    MsgBox " " & strFilePath _
                & "   !", vbExclamation
    Close #hFile
    hFile = 0
    Exit Function
 End If
    bytRecordMode = 0
    
    lngCharset = lngCharsetForString
 Select Case lngCharsetForString
  Case xDBFCharsetDOS866
  Case xDBFCharsetUkrStandard
  Case xDBFCharsetANSI
  Case Else
        lngCharset = xDBFCharsetDOS866
   Select Case Head.Type
    Case xDBFType_ImpExpSpec
        lngCharset = xDBFCharsetANSI
    Case xDBFType_FoxPro30
     If (Head.CodePage And 3) = 3 Then
        lngCharset = xDBFCharsetANSI
     End If
   End Select
 End Select
 If Head.Type = xDBFType_ImpExpSpec Then
    lngRecordLen = GetLong(Head.RecordLength)
 Else
    lngRecordLen = GetInteger(Head.RecordLength)
 End If
'        ,
'    .
'   ( ,  ) - .
 If Not CheckFieldsStruct Then
    Close #hFile
    hFile = 0
    Exit Function
 End If
'   
    ReDim CurData(0 To lngRecordLen - 1)
    Call MoveFirst
    
    OpenFile = True

OpenFile_exit:
    Exit Function
OpenFile_err:
    MsgBox Err.Description, vbCritical
    Resume OpenFile_exit
End Function

Public Function CreateNewFile(strFilePath As String, _
    Optional ByVal lngFileType As Long = conDBFType_SimpleNoMemo, _
    Optional ByVal lngCharsetForString As Long) As Boolean
On Error GoTo CreateNewFile_err
 
' If hFile <> 0 Then Close #hFile
' If hMemoFile <> 0 Then Close #hMemoFile
 If Head.Type > 0 Then
        strDBFFullPath = String(16, vbNullChar)
        CopyMemory Head, ByVal strDBFFullPath, 32
 End If
    Call CloseFile

    fRO = False
    strDBFFullPath = Trim$(strFilePath)
 If Len(strDBFFullPath) = 0 Then
        MsgBox "    !", vbExclamation
        Exit Function
 End If
    
    Head.Type = lngFileType
 If GetFileType = 0 Then
        MsgBox "   DBF !", vbExclamation
        strDBFFullPath = vbNullString
        Exit Function
 End If
 
 If CheckFileExists(strDBFFullPath, strFolder) Then
  If MsgBox(" " & strDBFFullPath & " !" _
            & vbCrLf & vbCrLf & " ?", vbQuestion + _
            vbOKCancel + vbDefaultButton2) = vbCancel Then
        strDBFFullPath = vbNullString
        Exit Function
  End If
        Kill strDBFFullPath
 End If
 Select Case Head.Type
  Case xDBFType_FoxPro2x, xDBFType_FoxPro30
        strMemoFullPath = ChangeFileExtention(strDBFFullPath, "fpt")
  Case Else
        strMemoFullPath = ChangeFileExtention(strDBFFullPath, "dbt")
 End Select
 If CheckFileExists(strMemoFullPath) Then
        Kill strMemoFullPath
 End If
        strMemoFullPath = vbNullString
        
        lngCharset = lngCharsetForString
 Select Case lngCharsetForString
  Case xDBFCharsetDOS866
  Case xDBFCharsetUkrStandard
  Case xDBFCharsetANSI
  Case Else
   If Head.Type = xDBFType_ImpExpSpec Then
        lngCharset = xDBFCharsetANSI
   Else
        lngCharset = xDBFCharsetDOS866
   End If
 End Select
    
    lngRecordLen = 1
    Head.RecordLength(0) = 1
 If Head.Type = xDBFType_FoxPro30 Then
    Head.Offset = 296
 Else
    Head.Offset = 33
 End If
    
    fNewFile = True
    CreateNewFile = True

CreateNewFile_exit:
    Exit Function
CreateNewFile_err:
    MsgBox Err.Description, vbCritical
    Resume CreateNewFile_exit
End Function

Function SaveNewFile() As Boolean
On Error GoTo SaveNewFile_err
Dim bytArr() As Byte
    
 If Len(strDBFFullPath) = 0 Then
    MsgBox "    !", vbExclamation
    Exit Function
 End If
 If lngFieldsCount = 0 Then
    MsgBox "    !", vbExclamation
    Exit Function
 End If
 Select Case Head.Type
  Case xDBFType_ImpExpSpec
  Case xDBFType_FoxPro30
   If Len(strMemoFullPath) > 0 Then
        Head.Flag = (Head.Flag Or 2)
   End If
  Case Else
   If Len(strMemoFullPath) = 0 Then
        Head.Type = conDBFType_SimpleNoMemo
   End If
 End Select
    hFile = FreeFile
    Open strDBFFullPath For Binary Access Read Write As hFile
          
    ReDim bytArr(0 To Head.Offset)
    Put hFile, 1, bytArr
    Put hFile, 1, Head           ' 
    Put hFile, , DBFFields
    Put hFile, , conHeaderTerminator
    Put hFile, Head.Offset + 1, conFileTerminator

    Erase bytArr
    fNewFile = False
    SaveNewFile = True

SaveNewFile_exit:
    Exit Function

SaveNewFile_err:
    Close hFile
    hFile = 0
    MsgBox Err.Description, vbCritical
    Resume SaveNewFile_exit
End Function

Private Function CheckNewFieldName(strFieldName As String, _
                                        bytArr() As Byte) As Boolean
Dim lngNameLen As Long
    
    strFieldName = Trim$(strFieldName)
    lngNameLen = Len(strFieldName)
 Select Case lngNameLen
  Case 0
    MsgBox "   !", vbExclamation
    Exit Function
  Case Is > 10
   If Head.Type = xDBFType_ImpExpSpec Then
    If lngNameLen > 11 Then
        MsgBox "    ImpExpSpec   " _
            & " 11 !", vbExclamation
        Exit Function
    End If
   Else
        MsgBox "     10 !", vbExclamation
        Exit Function
   End If
 End Select
 If CheckNumField(strFieldName, fNoMsgNotFound:=True) >= 0 Then
    MsgBox " " & strFieldName & "  !", vbExclamation
    Exit Function
 End If
 Select Case lngCharset
  Case xDBFCharsetANSI
  Case xDBFCharsetUkrStandard
    strFieldName = ConvANSItoDOS(strFieldName, fUkrStandard:=True)
  Case Else
    strFieldName = ConvANSItoDOS(strFieldName)
 End Select
    bytArr() = StrConv(strFieldName, vbFromUnicode)

    CheckNewFieldName = True
End Function

Private Function AppendField(ByVal strFieldName As String, _
                        ByVal lngFieldSize As Long) As Long
Dim lngFieldNum As Long, lngTemp As Long
Dim bytArr() As Byte

    AppendField = -1
 If Not CheckNewFieldName(strFieldName, bytArr) Then Exit Function
    
    lngFieldNum = lngFieldsCount
    lngTemp = MaxRecordLength - lngRecordLen
 If lngTemp < lngFieldSize Then
    MsgBox "    " & lngFieldSize & " " _
        & "  -    !" _
        & IIf(lngTemp = 0, vbNullString, vbCrLf & vbCrLf _
        & "   - " & lngTemp _
        & " ."), vbExclamation
    Exit Function
 End If
 
    ReDim Preserve DBFFieldsExt(0 To lngFieldNum)
  With DBFFieldsExt(lngFieldNum)
    .FieldName = strFieldName
    .Size = lngFieldSize
   If lngFieldNum = 0 Then
    .Offset = 1
   Else
    .Offset = DBFFieldsExt(lngFieldNum - 1).Offset + _
        DBFFieldsExt(lngFieldNum - 1).Size
   End If
  End With
    
    ReDim Preserve DBFFields(0 To lngFieldNum)
 With DBFFields(lngFieldNum)
    CopyMemory .FieldName(0), bytArr(0), GetArraySize(bytArr)
  
  If lngFieldSize > 255 Then
    .Length = lngFieldSize Mod 256
    .DecimalPlaces = (lngFieldSize - .Length) / 256
  Else
    .Length = lngFieldSize
  End If
 End With
    lngRecordLen = lngRecordLen + lngFieldSize
 With Head
    .Offset = .Offset + 32
  If Head.Type = xDBFType_ImpExpSpec Then
    CopyMemory .RecordLength(0), lngRecordLen, 4
  Else
    CopyMemory .RecordLength(0), lngRecordLen, 2
  End If
 End With
    lngFieldsCount = lngFieldsCount + 1
    AppendField = lngFieldNum
End Function

Public Function CreateField(strFieldName As String, _
                Optional ByVal intTypeDAO As Integer, _
                Optional ByVal bytTypeOriginal As Byte, _
                Optional ByVal lngFieldSize As Long, _
                Optional ByVal intDecPlaces As Integer = -1, _
                Optional fBynaryData As Boolean, _
                Optional fNotCheckTextSize As Boolean) As Long
'  .      
'intTypeDAO (   DAO)  bytTypeOriginal (   DBF).
'      .   ,  
'  xDBFType_ImpExpSpec bytTypeOriginal .  
'  bytTypeOriginal  .   , 
' intTypeDAO       
'  dBaseV  FoxPro3.x ( ),     ""
' ( bytTypeOriginal = 66),   .
'     dBaseV  FoxPro3.x.
'lngFieldSize -  .    , 
'    Numeric (  ).
'intDecPlaces -       
'  Numeric (  );
'             -    Precision   
' dbDecimal,      .
'fNotCheckTextSize -     
'  255 .
'fBynaryData -    MEMO  ,   - .
'    -1,  .
Dim lngFieldPos As Long, intNumericType As Integer
Const conMsgHeader = " "
    
    CreateField = -1
 If Not fNewFile Then
  If Head.RecordCount > 0 Then
    MsgBox "      , " _
        & "  ,     !", vbCritical
    Exit Function
  End If
  If Not AllowModify Then Exit Function
 End If
 If intTypeDAO = 0 And bytTypeOriginal = 0 Then
    MsgBox "   !", vbExclamation
    Exit Function
 End If
 If intTypeDAO <> 0 And (bytTypeOriginal = 0 Or _
                    Head.Type = xDBFType_ImpExpSpec) Then
    GoTo CreateByDAO
 End If
 
 Select Case bytTypeOriginal
  Case conFieldTypeString
    lngFieldPos = CreateTextField(strFieldName, lngFieldSize, _
                                fBynaryData, fNotCheckTextSize)
    intTypeDAO = daoTypeText
  Case conFieldTypeNumeric, 70  '"F"
    lngFieldPos = CreateNumericField(strFieldName, , lngFieldSize, intDecPlaces)
    intTypeDAO = daoTypeDouble
  Case conFieldTypeDate, conFieldTypeDateTime
    lngFieldPos = CreateDateField(strFieldName)
    intTypeDAO = daoTypeDate
  Case conFieldTypeLogical
    lngFieldPos = CreateLogicalField(strFieldName)
    intTypeDAO = daoTypeBoolean
  Case conFieldTypeMemo, conFieldTypeGeneral, 80    '"P"
    lngFieldPos = CreateMemoField(strFieldName, fBynaryData)
   If fBynaryData Then
    intTypeDAO = daoTypeLongBinary
   Else
    intTypeDAO = daoTypeMemo
   End If
  Case 66   '"B"
   If intTypeDAO = daoTypeLongBinary Then
    lngFieldPos = CreateMemoField(strFieldName, True)
   Else
    intNumericType = daoTypeDouble
   End If
  Case conFieldTypeDouble:   intNumericType = daoTypeDouble
  Case conFieldTypeLong:     intNumericType = daoTypeLong
  Case conFieldTypeCurrency: intNumericType = daoTypeCurrency
  Case conFieldTypeInteger:  intNumericType = daoTypeInteger
  Case conFieldTypeByte:     intNumericType = daoTypeByte
  Case conFieldTypeSingle:   intNumericType = daoTypeSingle
  Case conFieldTypeVariant:  intNumericType = daoTypeDecimal
  Case Else '  
   If lngFieldSize <= 0 Then Exit Function
   If MsgBox("  """ & Chr(bytTypeOriginal) & """(" _
            & Hex(bytTypeOriginal) & "  !" & vbCrLf & vbCrLf _
            & "     " & lngFieldSize _
            & " ?", vbQuestion + vbYesNo + vbDefaultButton2, _
            conMsgHeader) = vbNo Then
        Exit Function
   End If
        
        lngFieldPos = AppendField(strFieldName, lngFieldSize)
   If lngFieldPos >= 0 Then
        DBFFields(lngFieldPos).Type = bytTypeOriginal
        DBFFields(lngFieldPos).DecimalPlaces = intDecPlaces
        DBFFieldsExt(lngFieldPos).TypeDBF = bytTypeOriginal
        DBFFieldsExt(lngFieldPos).TypeDAO = daoTypeBinary
   End If
        CreateField = lngFieldPos
        Exit Function
 End Select
 If intNumericType > 0 Then
    lngFieldPos = CreateNumericField(strFieldName, intNumericType)
    intTypeDAO = intNumericType
 End If
 If lngFieldPos >= 0 Then
  With DBFFields(lngFieldPos)
   If .Type = 0 Then .Type = bytTypeOriginal
  End With
 End If
    GoTo Finish
'--------------------------------------------------------------
CreateByDAO:
 Select Case intTypeDAO
  Case daoTypeText
    lngFieldPos = CreateTextField(strFieldName, lngFieldSize, _
                            fBynaryData, fNotCheckTextSize)
  Case daoTypeDate
    lngFieldPos = CreateDateField(strFieldName)
  Case daoTypeBoolean
    lngFieldPos = CreateLogicalField(strFieldName)
  Case daoTypeMemo
    lngFieldPos = CreateMemoField(strFieldName, fBynaryData)
  Case daoTypeLongBinary
    lngFieldPos = CreateMemoField(strFieldName, True)
  Case daoTypeDouble, daoTypeLong, daoTypeCurrency, daoTypeInteger, _
            daoTypeSingle, daoTypeByte, daoTypeDecimal
    lngFieldPos = CreateNumericField(strFieldName, intTypeDAO, _
                                lngFieldSize, intDecPlaces)
  Case Else
    MsgBox "   !", vbCritical, conMsgHeader
    Exit Function
 End Select

Finish:
 If lngFieldPos >= 0 Then
  If Not CheckFieldsStruct(True) Then Exit Function
 End If
    CreateField = lngFieldPos
End Function

Public Function CreateFieldFromADO(strFieldName As String, _
                Optional ByVal intTypeADO As Integer, _
                Optional ByVal lngFieldSize As Long, _
                Optional ByVal intDecPlaces As Integer = -1, _
                Optional fBynaryData As Boolean, _
                Optional fNotCheckTextSize As Boolean) As Long
'   ,      ADO.
'  ADO   .    DAO, 
'   CreateField.
Dim i As Integer

 Select Case DBFFieldsExt(intTypeADO).TypeDAO
  Case 130: i = daoTypeText             'adVarWChar
  Case 5: i = daoTypeDouble             'adDouble
  Case 7: i = daoTypeDate               'adDate
  Case 11: i = daoTypeBoolean           'adBoolean
  Case 201: i = daoTypeMemo             'adLongVarWChar
  Case 3: i = daoTypeLong               'adInteger
  Case 2: i = daoTypeInteger            'adSmallInt
  Case 17: i = daoTypeByte              'adUnsignedTinyInt
  Case 6: i = daoTypeCurrency           'adCurrency
  Case 4: i = daoTypeSingle             'adSingle
  Case 205: i = daoTypeLongBinary       'adLongVarBinary
  Case 128: i = daoTypeBinary           'adBinary
  Case Else: i = -1
 End Select
    CreateFieldFromADO = CreateField(strFieldName, i, 0, _
        lngFieldSize, intDecPlaces, fBynaryData, fNotCheckTextSize)
End Function

Private Function CreateTextField(strFieldName As String, _
                    Optional ByVal lngFieldSize As Long = 50, _
                    Optional fBynaryData As Boolean, _
                    Optional fNotCheckSize As Boolean) As Long
'         lngFieldSize.
'  fBynaryData -    .
'  fNotCheckSize,   ImpExpSpec , -
'     65535 .  - 254 ,  
'  255   254,    -  .
'    -1,  .
Dim lngFieldPos As Long

    CreateTextField = -1
 Select Case lngFieldSize
  Case Is <= 0
        lngFieldSize = 50
  Case Is > 254
   If Head.Type = xDBFType_ImpExpSpec Or fNotCheckSize Then
   Else
    If lngFieldSize = 255 Then
        lngFieldSize = 254
    Else
        MsgBox "     254 !", vbExclamation
        Exit Function
    End If
   End If
 End Select
    lngFieldPos = AppendField(strFieldName, lngFieldSize)
 If lngFieldPos < 0 Then Exit Function
 With DBFFields(lngFieldPos)
    .Type = conFieldTypeString
  If fBynaryData Then .Flags = .Flags Or 2
 End With
 With DBFFieldsExt(lngFieldPos)
    .TypeDBF = conFieldTypeString
  If fBynaryData Then .Binary = True
  If .Size > 255 Then
    .TypeDAO = daoTypeMemo
  Else
    .TypeDAO = daoTypeText
  End If
 End With
    CreateTextField = lngFieldPos
End Function

Private Function CreateNumericField(strFieldName As String, _
        Optional ByVal intFieldTypeDAO As Integer, _
        Optional ByVal intFieldSize As Integer, _
        Optional ByVal intDecimalPlaces As Integer = -1) As Long
'     ,     
'      :
'  intFieldTypeDAO -    Access   DAO;
'  intFieldSize -      ("N" - Numeric);
'  intDecimalPlaces -   .
'  xDBFType_ImpExpSpec  xDBFType_FoxPro30  
'    intFieldTypeDAO,     
' (  dbNumeric) -     
'  ("N")  ,  .    
' ,      Null.
'  xDBFType_ImpExpSpec,    dbDecimal
' (daoTypeDecimal),    Variant (16 ),
'    Null  Empty.   
'    Variant,    
' ,    .
'  xDBFType_FoxPro30  Single  Decimal 
'  Double,   Byte  Integer -  Long.
'       .  ("N").
'      ,  
'     intFieldSize.
'     -   13.5 ( - 19 .)
'    intFieldTypeDAO -     
'    ,      .
'  intFieldSize ,     
'  intDecimalPlaces / intFieldTypeDAO (  - 5 ).
'    -1,  .
Dim lngFieldPos As Long, bytDBFFieldType As Byte, fExpImp As Boolean

        CreateNumericField = -1
        fExpImp = (Head.Type = xDBFType_ImpExpSpec)
        bytDBFFieldType = conFieldTypeNumeric
 
 Select Case Head.Type
  Case xDBFType_ImpExpSpec, xDBFType_FoxPro30
   Select Case intFieldTypeDAO
    Case Is <= 0, 19        '19 - dbNumeric
        GoTo NumericFieldProperties
    Case daoTypeLong
        bytDBFFieldType = conFieldTypeLong
    Case daoTypeDouble
        bytDBFFieldType = conFieldTypeDouble
    Case daoTypeCurrency
        bytDBFFieldType = conFieldTypeCurrency
    Case daoTypeByte
     If fExpImp Then
        bytDBFFieldType = conFieldTypeByte
     Else
        bytDBFFieldType = conFieldTypeLong
        intFieldTypeDAO = daoTypeLong
     End If
    Case daoTypeInteger
     If fExpImp Then
        bytDBFFieldType = conFieldTypeInteger
     Else
        bytDBFFieldType = conFieldTypeLong
        intFieldTypeDAO = daoTypeLong
     End If
    Case daoTypeSingle
     If fExpImp Then
        bytDBFFieldType = conFieldTypeSingle
     Else
        bytDBFFieldType = conFieldTypeDouble
        intFieldTypeDAO = daoTypeDouble
     End If
    Case daoTypeDecimal
     If fExpImp Then
        bytDBFFieldType = conFieldTypeVariant
     Else
        bytDBFFieldType = conFieldTypeDouble
        intFieldTypeDAO = daoTypeDouble
     End If
   End Select
  Case Else
        GoTo NumericFieldProperties
 End Select
 Select Case intFieldTypeDAO
  Case daoTypeLong: intFieldSize = 4
  Case daoTypeDouble: intFieldSize = 8
  Case daoTypeCurrency: intFieldSize = 8
  Case daoTypeInteger: intFieldSize = 2
  Case daoTypeSingle: intFieldSize = 4
  Case daoTypeByte: intFieldSize = 1
  Case daoTypeDecimal: intFieldSize = 16
 End Select
        GoTo CreateFieldStep
    
NumericFieldProperties:
 Select Case intFieldSize
  Case Is <= 0
   Select Case intFieldTypeDAO
    Case daoTypeLong
        intFieldSize = 11
    Case daoTypeByte
        intFieldSize = 3
    Case daoTypeInteger
        intFieldSize = 6
    Case Else
        intFieldSize = 19
   End Select
  Case Is >= 20
   Select Case Head.Type
    Case xDBFType_ImpExpSpec
    Case xDBFType_FoxPro2x, xDBFType_FoxPro30
        intFieldSize = 20
    Case Else
        intFieldSize = 19
   End Select
 End Select
 
 Select Case intDecimalPlaces
  Case Is < 0
   Select Case intFieldTypeDAO
    Case daoTypeLong, daoTypeInteger, daoTypeByte
        intDecimalPlaces = 0
    Case daoTypeCurrency
        intDecimalPlaces = 2
    Case Else
        intDecimalPlaces = 5
   End Select
  Case Is > (intFieldSize - 2)
        intDecimalPlaces = intFieldSize - 2
 End Select
 Select Case bytDBFFieldType
  Case conFieldTypeNumeric, 70     '70 - "F" (Float)
  Case Else
        bytDBFFieldType = conFieldTypeNumeric
 End Select
 
CreateFieldStep:
    lngFieldPos = AppendField(strFieldName, intFieldSize)
 If lngFieldPos < 0 Then Exit Function
 If intDecimalPlaces < 0 Then intDecimalPlaces = 0
 With DBFFields(lngFieldPos)
    .Type = bytDBFFieldType
    .DecimalPlaces = intDecimalPlaces
 End With
    CreateNumericField = lngFieldPos
End Function

Private Function CreateLogicalField(strFieldName As String) As Long
'  .
'    -1,  .
Dim lngFieldPos As Long
    
    lngFieldPos = AppendField(strFieldName, 1)
 If lngFieldPos >= 0 Then
    DBFFields(lngFieldPos).Type = conFieldTypeLogical
 End If
    CreateLogicalField = lngFieldPos
End Function

Private Function CreateDateField(strFieldName As String) As Long
'   ""  "/"     .
'    -1,  .
Dim lngFieldPos As Long
    
    lngFieldPos = AppendField(strFieldName, 8)
 If lngFieldPos >= 0 Then
  With DBFFields(lngFieldPos)
   Select Case Head.Type
    Case xDBFType_FoxPro30, xDBFType_ImpExpSpec
        .Type = conFieldTypeDateTime
    Case Else
        .Type = conFieldTypeDate
   End Select
  End With
 End If
    CreateDateField = lngFieldPos
End Function

Private Function CreateMemoField(strFieldName As String, _
                    Optional fBynaryData As Boolean) As Long
' MEMO .
'    -1,  .
Dim lngFieldPos As Long
    
    CreateMemoField = -1
 If Head.Type = conDBFType_SimpleNoMemo Then
    MsgBox "    ,  " _
        & " MEMO !", vbExclamation
    Exit Function
 End If
 Select Case Head.Type
  Case xDBFType_FoxPro30, xDBFType_ImpExpSpec
    lngFieldPos = AppendField(strFieldName, 4)
  Case Else
    lngFieldPos = AppendField(strFieldName, 10)
 End Select
 If lngFieldPos < 0 Then Exit Function
 
 With DBFFields(lngFieldPos)
  If fBynaryData Then
        .Type = conFieldTypeGeneral
        .Flags = .Flags Or 2
        DBFFieldsExt(lngFieldPos).Binary = True
  Else
        .Type = conFieldTypeMemo
  End If
 End With
 
 Select Case Head.Type
  Case xDBFType_FoxPro2x, xDBFType_FoxPro30
    strMemoFullPath = ChangeFileExtention(strDBFFullPath, "fpt")
  Case Else
    strMemoFullPath = ChangeFileExtention(strDBFFullPath, "dbt")
 End Select
    CreateMemoField = lngFieldPos
End Function

Public Function GetFileType(Optional strRetTypeName As String) As Byte
 Select Case Head.Type
  Case 3
    strRetTypeName = "FoxBASE+/dBASE III+, no memo"
  Case xDBFType_dBASE_III
    strRetTypeName = "FoxBASE+/dBASE III+ with memo"
  Case xDBFType_dBASE_IV_V
    strRetTypeName = "dBASE IV with memo"
  Case xDBFType_FoxPro2x
    strRetTypeName = "FoxPro 2.x (or earlier) with memo"
  Case xDBFType_FoxPro30
    strRetTypeName = "FoxPro 3.x/Visual FoxPro"
  Case xDBFType_ImpExpSpec
    strRetTypeName = "File Import/Export Special"
  Case 2, &HFB
    strRetTypeName = "FoxBASE"
' &H43 - dBASE IV SQL table files, no memo
' &H63 - dBASE IV SQL system files, no memo
' &HCB - dBASE IV SQL table files, with memo
  Case Else
    Exit Function
 End Select
    GetFileType = Head.Type
End Function

Public Property Get GetCharSet() As Long
    GetCharSet = lngCharset
End Property

Private Function CheckFieldsStruct( _
                    Optional fCreateNewField As Boolean) As Boolean
Dim i As Long, s As String
Dim lngSize As Long, lngOffset As Long
Const conMsgHeader = "  ."

        ReDim DBFFieldsExt(0 To lngFieldsCount - 1)
        lngOffset = 1
 For i = 0 To lngFieldsCount - 1
        s = GetString(DBFFields(i).FieldName)
        lngSize = InStr(1, s, vbNullChar, vbBinaryCompare)
  If lngSize > 1 Then
        s = Left$(s, lngSize - 1)
  End If
        DBFFieldsExt(i).FieldName = Trim$(s)
        
        s = vbNullString
        lngSize = DBFFields(i).Length
  
  Select Case DBFFields(i).Type
   Case 70      '"F"
' "F" ( "Float") -   "N" ( "Numeric").
        DBFFieldsExt(i).TypeDBF = conFieldTypeNumeric
   
   Case 66      '"B"
'  "",  Visual FoxPro   "Double",   dBaseV -
' "Binary".    "B"   "G" ( "General").
    If Head.Type = xDBFType_FoxPro30 Then
        DBFFieldsExt(i).TypeDBF = conFieldTypeDouble
    Else
        DBFFieldsExt(i).TypeDBF = conFieldTypeGeneral
    End If
   
   Case 80
' "P" ( "Picture") -   "G" ( "General").
        DBFFieldsExt(i).TypeDBF = conFieldTypeGeneral
   Case Else
        DBFFieldsExt(i).TypeDBF = DBFFields(i).Type
  End Select
  
  Select Case DBFFieldsExt(i).TypeDBF
   Case conFieldTypeString
    If DBFFields(i).DecimalPlaces > 0 Then
        lngSize = DBFFields(i).Length + _
                    256 * DBFFields(i).DecimalPlaces
        DBFFieldsExt(i).TypeDAO = daoTypeMemo
    Else
        DBFFieldsExt(i).TypeDAO = daoTypeText
    End If
    Select Case Head.Type
     Case xDBFType_FoxPro30, xDBFType_ImpExpSpec
      If (DBFFields(i).Flags And 4) Then
        DBFFieldsExt(i).TypeDAO = daoTypeLongBinary
      End If
    End Select
   Case conFieldTypeMemo, conFieldTypeGeneral
    If DBFFieldsExt(i).TypeDBF = conFieldTypeMemo Then
        DBFFieldsExt(i).TypeDAO = daoTypeMemo
     Select Case Head.Type
      Case xDBFType_FoxPro30, xDBFType_ImpExpSpec
       If (DBFFields(i).Flags And 4) Then
        DBFFieldsExt(i).TypeDAO = daoTypeLongBinary
       End If
     End Select
    Else
        DBFFieldsExt(i).TypeDAO = daoTypeLongBinary
    End If
    If Not fCreateNewField Then
     Select Case Head.Type
      Case xDBFType_FoxPro2x, xDBFType_FoxPro30
        strMemoFullPath = ChangeFileExtention(strDBFFullPath, "fpt")
      Case Else
        strMemoFullPath = ChangeFileExtention(strDBFFullPath, "dbt")
     End Select
     If Not CheckFileExists(strMemoFullPath) Then
        strMemoFullPath = vbNullString
     End If
    End If
    Select Case Head.Type
     Case xDBFType_FoxPro30, xDBFType_ImpExpSpec
      If lngSize <> 4 Then
        lngSize = 4
        GoSub FieldErrorMessage
      End If
    End Select
   Case conFieldTypeNumeric
    If DBFFields(i).DecimalPlaces = 0 And DBFFields(i).Length <= 9 Then
     If DBFFields(i).Length <= 4 Then
        DBFFieldsExt(i).TypeDAO = daoTypeInteger
     Else
        DBFFieldsExt(i).TypeDAO = daoTypeLong
     End If
    Else
        DBFFieldsExt(i).TypeDAO = daoTypeDouble
    End If
   Case conFieldTypeDate, conFieldTypeDateTime
        DBFFieldsExt(i).TypeDAO = daoTypeDate
    If lngSize <> 8 Then
        lngSize = 8
        GoSub FieldErrorMessage
    End If
   Case conFieldTypeLogical
        DBFFieldsExt(i).TypeDAO = daoTypeBoolean
    If lngSize <> 1 Then
        lngSize = 1
        GoSub FieldErrorMessage
    End If
   Case conFieldTypeDouble
        DBFFieldsExt(i).TypeDAO = daoTypeDouble
    If lngSize <> 8 Then
        lngSize = 8
        GoSub FieldErrorMessage
    End If
   Case conFieldTypeLong
        DBFFieldsExt(i).TypeDAO = daoTypeLong
    If lngSize <> 4 Then
        lngSize = 4
        GoSub FieldErrorMessage
    End If
   Case conFieldTypeCurrency
        DBFFieldsExt(i).TypeDAO = daoTypeCurrency
    If lngSize <> 8 Then
        lngSize = 8
        GoSub FieldErrorMessage
    End If
   Case conFieldTypeInteger
        DBFFieldsExt(i).TypeDAO = daoTypeInteger
    If lngSize <> 2 Then
        lngSize = 2
        GoSub FieldErrorMessage
    End If
   Case conFieldTypeByte
        DBFFieldsExt(i).TypeDAO = daoTypeByte
    If lngSize <> 1 Then
        lngSize = 1
        GoSub FieldErrorMessage
    End If
   Case conFieldTypeSingle
        DBFFieldsExt(i).TypeDAO = daoTypeSingle
    If lngSize <> 4 Then
        lngSize = 4
        GoSub FieldErrorMessage
    End If
   Case conFieldTypeVariant
        DBFFieldsExt(i).TypeDAO = daoTypeDecimal
    If lngSize <> 16 Then
        lngSize = 16
        GoSub FieldErrorMessage
    End If
   Case Else    '   
    If MsgBox("  """ & DBFFieldsExt(i).FieldName _
            & """  !" & vbCrLf & vbCrLf & "?", _
            vbQuestion + vbOKCancel + vbDefaultButton2, _
            conMsgHeader) = vbCancel Then
        Exit Function
    End If
        DBFFieldsExt(i).TypeDAO = daoTypeBinary
  End Select
        DBFFieldsExt(i).Size = lngSize
        DBFFieldsExt(i).Offset = lngOffset
        lngOffset = lngOffset + lngSize
 Next i
 
 If lngRecordLen <> lngOffset Then
    s = "      (" _
        & lngRecordLen & ")    (" _
        & lngOffset & ") !" & vbCrLf & vbCrLf _
        & " ."
    MsgBox s, vbExclamation, conMsgHeader
    Exit Function
 End If
    CheckFieldsStruct = True
    Exit Function

FieldErrorMessage:
    s = "  " & DBFFieldsExt(i).FieldName & " " _
        & "   " & DBFFields(i).Length _
        & " ." & vbCrLf & vbCrLf & " " _
        & lngSize & " ."
    MsgBox s, vbExclamation, conMsgHeader
    Return
End Function

Public Property Get GetFieldName(ByVal lngFieldNum As Long, _
                    Optional bytRetType As Byte, _
                    Optional bytRetFlags As Byte) As String
'    ,   lngFieldNum.
'   DBF    ,  
'   :
'  bytRetType -   (ANSI   "C", "N" ,"D"  ..);
'  bytRetFlags -  (  -  FoxPro 3.)
 If CheckNumField(lngFieldNum) < 0 Then Exit Property
 With DBFFields(lngFieldNum)
    bytRetType = .Type
    bytRetFlags = .Flags
 End With
    GetFieldName = DBFFieldsExt(lngFieldNum).FieldName
End Property

Public Property Let ChangeFieldName(vIndex As Variant, _
        Optional fNoSave As Boolean, strNewFieldName As String)
'   ,     
'    .
'vIndex -    .
'  fNoSave      ,  
'          .
Dim lngFieldNum As Long, bytArr() As Byte
Dim lngOffset As Long

 If hFile = 0 Then Exit Property
 If Not AllowModify Then Exit Property
    
    lngFieldNum = CheckNumField(vIndex)
 If lngFieldNum < 0 Then Exit Property
 If Not CheckNewFieldName(strNewFieldName, bytArr) Then Exit Property

 With DBFFieldsExt(lngFieldNum)
    .FieldName = strNewFieldName
 End With
 If fRO Or fNoSave Then Exit Property
 
 With DBFFields(lngFieldNum)
    CopyMemory .FieldName(0), bytArr(0), GetArraySize(bytArr)
 End With
    lngOffset = Len(Head) + lngFieldNum * 32 + 1
    Put hFile, lngOffset, DBFFields(lngFieldNum)
End Property

Public Property Get GetFieldTypeOriginal(vIndex As Variant) As Byte
'  ,   .
' ASCI   ("C", "N"  ..)
'vIndex -    .
Dim lngFieldNum As Long
    lngFieldNum = CheckNumField(vIndex)
 If lngFieldNum < 0 Then Exit Property
    GetFieldTypeOriginal = DBFFields(lngFieldNum).Type
End Property

Public Property Get GetFieldTypeForDAO(vIndex As Variant) As Long
'  ,   DAO.
'vIndex -    .
Dim lngFieldNum As Long
    lngFieldNum = CheckNumField(vIndex)
 If lngFieldNum < 0 Then Exit Property
    GetFieldTypeForDAO = DBFFieldsExt(lngFieldNum).TypeDAO
End Property

Public Property Get GetFieldTypeForADO(vIndex As Variant) As Long
'  ,   ADO.
'vIndex -    .
Dim lngFieldNum As Long, l As Long
    lngFieldNum = CheckNumField(vIndex)
 If lngFieldNum < 0 Then Exit Property

 Select Case DBFFieldsExt(lngFieldNum).TypeDAO
  Case daoTypeText: l = 130             'adVarWChar
  Case daoTypeDouble: l = 5             'adDouble
  Case daoTypeDate: l = 7               'adDate
  Case daoTypeBoolean: l = 11           'adBoolean
  Case daoTypeMemo: l = 201             'adLongVarWChar
  Case daoTypeLong: l = 3               'adInteger
  Case daoTypeInteger: l = 2            'adSmallInt
  Case daoTypeByte: l = 17              'adUnsignedTinyInt
  Case daoTypeCurrency: l = 6           'adCurrency
  Case daoTypeSingle: l = 4             'adSingle
  Case daoTypeLongBinary: l = 205       'adLongVarBinary
  Case daoTypeBinary: l = 128           'adBinary
 End Select
    GetFieldTypeForADO = l
End Property

Public Property Get GetFieldSize(vIndex As Variant) As Long
'  .  MEMO  -  .
'vIndex -    .
Dim lngFieldNum As Long
    lngFieldNum = CheckNumField(vIndex)
 If lngFieldNum < 0 Then Exit Property
  GetFieldSize = DBFFieldsExt(lngFieldNum).Size
End Property

Public Property Get GetFieldDecPlaces(vIndex As Variant) As Long
'       "Numeric".
'vIndex -    .
Dim lngFieldNum As Long
    
    lngFieldNum = CheckNumField(vIndex)
 If lngFieldNum < 0 Then Exit Property
 If DBFFields(lngFieldNum).Type = conFieldTypeNumeric Then
  GetFieldDecPlaces = DBFFields(lngFieldNum).DecimalPlaces
 End If
End Property

Public Property Get GetFieldIsBinary(vIndex As Variant) As Boolean
' True,    MEMO    .
'vIndex -    .
Dim lngFieldNum As Long
    lngFieldNum = CheckNumField(vIndex)
 If lngFieldNum < 0 Then Exit Property
 Select Case DBFFieldsExt(lngFieldNum).TypeDAO
  Case daoTypeBinary, daoTypeLongBinary
    GetFieldIsBinary = True
 End Select
End Property

Public Property Get FieldsCount() As Long
    FieldsCount = lngFieldsCount
End Property

Public Property Get RecordCount(Optional fIncludeDeleted As Boolean) As Long
'   , ,  
' fIncludeDeleted,  ,  .
'   .
Dim lngSaveCurRec As Long, lngActualRec As Long
 If fIncludeDeleted Then
    RecordCount = Head.RecordCount
    Exit Property
 End If
    lngSaveCurRec = CurRec
    MoveFirst
 Do Until NoRecord
    lngActualRec = lngActualRec + 1
    MoveNext
 Loop
    CurRec = lngSaveCurRec
    Seek hFile, (Head.Offset + CurRec * lngRecordLen + 1)
    Get hFile, , CurData
    RecordCount = lngActualRec
End Property

Public Property Get AbsolutePosition() As Long
    AbsolutePosition = CurRec
End Property

Public Property Get RecordIsDelete() As Boolean
 If NoRecord Then Exit Property
    RecordIsDelete = (CurData(0) <> 32) '  - .
End Property

Private Property Get MaxRecordLength() As Long
  If Head.Type = xDBFType_ImpExpSpec Then
    MaxRecordLength = 2147483647    '2^31-1
  Else
    MaxRecordLength = 65535         '2^16-1
  End If
End Property

Public Sub MoveFirst(Optional fIncludeDeleted As Boolean)
'    , ,  
' fIncludeDeleted,   ,  .
' "Edit"  "AddNew" .
    Seek hFile, Head.Offset + 1
    CurRec = 0
'   
    Get hFile, , CurData
' fIncludeDeleted = False -   .
 If Not fIncludeDeleted Then
    If RecordIsDelete Then MoveNext
 End If
 If bytRecordMode <> 0 Then
    bytRecordMode = 0
    Erase BuffData
 End If
End Sub

Public Sub MoveNext(Optional fIncludeDeleted As Boolean)
'    , ,  
' fIncludeDeleted,   ,  .
' "Edit"  "AddNew" .
 If NoRecord Then
    MsgBox "  !", vbCritical
    Exit Sub
 End If
NextRecord:
    CurRec = CurRec + 1
    Seek hFile, (Head.Offset + CurRec * lngRecordLen + 1)
 If Not NoRecord Then
'   
    Get hFile, , CurData
' fIncludeDeleted = False -   .
  If Not fIncludeDeleted Then
    If RecordIsDelete Then GoTo NextRecord
  End If
 End If
 If bytRecordMode <> 0 Then
    bytRecordMode = 0
    Erase BuffData
 End If
End Sub

Public Sub GoToRecord(lngIndex As Long)
'     ,  .
' "Edit"  "AddNew" .
 Select Case lngIndex
  Case 0 To IIf(Head.RecordCount = 0, 0, Head.RecordCount - 1)
  Case Else
    MsgBox "       0  " _
        & Head.RecordCount - 1 & " !", vbExclamation
    Exit Sub
 End Select
    CurRec = lngIndex
    Seek hFile, (Head.Offset + CurRec * lngRecordLen + 1)
 If Not NoRecord Then
'   
    Get hFile, , CurData
 Else
    Erase CurData
 End If
 If bytRecordMode <> 0 Then
    bytRecordMode = 0
    Erase BuffData
 End If
End Sub

Public Property Get NoRecord() As Boolean
    NoRecord = (CurRec >= Head.RecordCount)
End Property

Private Function CheckNumField(vIndex As Variant, _
                    Optional fNoMsgNotFound As Boolean) As Long
Dim i As Long

    CheckNumField = -1
 If VarType(vIndex) = vbString Then
  If Len(Trim$(vIndex)) = 0 Then Exit Function
  For i = 0 To lngFieldsCount - 1
   If StrComp(DBFFieldsExt(i).FieldName, _
                            CStr(vIndex), vbTextCompare) = 0 Then
        CheckNumField = i
        Exit Function
   End If
  Next i
  If Not fNoMsgNotFound Then
    MsgBox " """ & CStr(vIndex) & """  !", vbExclamation
  End If
    Exit Function
 ElseIf IsNumeric(vIndex) Then
  Select Case CInt(vIndex)
   Case Is < 0
   Case 0 To lngFieldsCount - 1
        CheckNumField = CInt(vIndex)
   Case Else
        MsgBox "       0  " _
            & lngFieldsCount - 1 & "!", vbExclamation
  End Select
    Exit Function
 Else
    MsgBox "      " _
        & "  !", vbExclamation
    Exit Function
 End If
End Function

Public Function GetFieldValue(vIndex As Variant, _
                Optional ByVal fBinary As Boolean, _
                Optional lngMemoChunkSize As Long, _
                Optional fNullIfNotFoundField As Boolean) As Variant
'  ,   vIndex (  ).
'fBinary -   ,   
' (         
'  ).
'lngMemoChunkSize -        
' .
'fNullIfNotFoundField -   Null   
'         ( 
'     < 0  Null   ).On Error GoTo GetFieldValue_err
Dim lngFieldNum As Long
Dim bytArr() As Byte, vValue As Variant

    GetFieldValue = Null
 If hFile = 0 And Not fNewFile Then Exit Function
 If bytRecordMode = 0 And NoRecord Then Exit Function
 
    lngFieldNum = CheckNumField(vIndex, fNullIfNotFoundField)
 If lngFieldNum < 0 Then Exit Function
    
 With DBFFieldsExt(lngFieldNum)
    ReDim bytArr(0 To .Size - 1)
  If bytRecordMode = 0 Then
   If .Offset > GetArraySize(CurData) Then Exit Function
    CopyMemory bytArr(0), CurData(.Offset), .Size
  Else
   If .Offset > GetArraySize(BuffData) Then Exit Function
    CopyMemory bytArr(0), BuffData(.Offset), .Size
  End If
  If .TypeDAO = daoTypeLongBinary Then fBinary = True
  If .TypeDAO = daoTypeBinary Then fBinary = True
'  If (DBFFields(lngFieldNum).Flags And 4) Then fBinary = True
 End With
 If fBinary Then
  Select Case DBFFieldsExt(lngFieldNum).TypeDBF
   Case conFieldTypeMemo, conFieldTypeGeneral
   Case Else
        GetFieldValue = bytArr()
        Exit Function
  End Select
 End If
 
 Select Case DBFFieldsExt(lngFieldNum).TypeDBF
  Case conFieldTypeString
        GetFieldValue = GetString(bytArr)
  Case conFieldTypeMemo
        GetFieldValue = GetMemo(bytArr(), lngMemoChunkSize, fBinary)
  Case conFieldTypeDate
        GetFieldValue = GetDate(bytArr)
  Case conFieldTypeNumeric
        GetFieldValue = GetNumeric(bytArr)
  Case conFieldTypeLogical
   Select Case bytArr(0)
    Case 89, 121, 84, 116   'Y,y,T,t.
        GetFieldValue = True
    Case Else
        GetFieldValue = False
   End Select
  
  Case conFieldTypeDateTime
        GetFieldValue = GetDateTime(bytArr)
  Case conFieldTypeLong
        GetFieldValue = GetLong(bytArr)
  Case conFieldTypeDouble
        GetFieldValue = GetDouble(bytArr)
  Case conFieldTypeCurrency
        GetFieldValue = GetCurrency(bytArr)
  Case conFieldTypeInteger
        GetFieldValue = GetInteger(bytArr)
  Case conFieldTypeSingle
        GetFieldValue = GetSingle(bytArr)
  Case conFieldTypeByte
        GetFieldValue = bytArr(0)
  Case conFieldTypeVariant
        GetFieldValue = GetDecimal(bytArr)
 End Select

GetFieldValue_exit:
    Exit Function
GetFieldValue_err:
    MsgBox Err.Description, vbCritical
    Resume GetFieldValue_exit
End Function

Public Property Let SetFieldValue(vIndex As Variant, _
        Optional fWriteMemoChunkMode As Boolean, vValue As Variant)
On Error GoTo SetFieldValue_err
Dim lngFieldNum As Long
Dim bytArr() As Byte

 If hFile = 0 And Not fNewFile Then Exit Property
 If bytRecordMode = 0 Then
    MsgBox "  ""Edit""  ""AddNew""!", vbExclamation
    Exit Property
 End If
    lngFieldNum = CheckNumField(vIndex)
 If lngFieldNum < 0 Then Exit Property
 
 With DBFFieldsExt(lngFieldNum)
  If VarType(vValue) = (vbArray Or vbByte) Then
   Select Case DBFFieldsExt(lngFieldNum).TypeDBF
    Case conFieldTypeMemo, conFieldTypeGeneral
    Case Else
        bytArr() = vValue
     If (UBound(bytArr) - LBound(bytArr) + 1) <> .Size Then
        MsgBox "    " _
            & "  !" & vbCrLf & vbCrLf _
            & " " & .Size & " .", vbExclamation
     Else
        CopyMemory BuffData(.Offset), bytArr(LBound(bytArr)), .Size
     End If
        Exit Property
   End Select
  ElseIf DBFFieldsExt(lngFieldNum).TypeDAO = daoTypeBinary Then
    MsgBox " """ & DBFFieldsExt(lngFieldNum).FieldName _
            & """   !" & vbCrLf _
            & "      " _
            & "   " & DBFFieldsExt(lngFieldNum).Size _
            & " .", vbExclamation
        Exit Property
  End If
 
    ReDim bytArr(0 To .Size - 1)
    CopyMemory bytArr(0), BuffData(.Offset), .Size
 
  Select Case .TypeDBF
   Case conFieldTypeString
        Call SetString(vValue, bytArr)
   Case conFieldTypeMemo, conFieldTypeGeneral
        Call SetMemo(hMemoFile, bytArr, vValue, _
            fWriteMemoChunkMode, .TypeDBF = conFieldTypeGeneral)
   Case conFieldTypeDate
        Call SetDate(vValue, bytArr)
   Case conFieldTypeNumeric
        Call SetNumeric(vValue, bytArr, _
                            DBFFields(lngFieldNum).DecimalPlaces)
   Case conFieldTypeLogical
    If Head.Type = xDBFType_ImpExpSpec Then
        bytArr(0) = 0
    Else
        bytArr(0) = 70             '"F"
    End If
    If IsNumeric(vValue) Then
     If CBool(vValue) Then
        bytArr(0) = 84             '"T"
     End If
    End If
 
   Case conFieldTypeLong, conFieldTypeDouble, conFieldTypeCurrency, _
            conFieldTypeInteger, conFieldTypeSingle, conFieldTypeByte
    If IsNumeric(vValue) Then
     Select Case .TypeDBF
      Case conFieldTypeLong
        CopyMemory bytArr(0), CLng(vValue), 4
      Case conFieldTypeDouble
        CopyMemory bytArr(0), CDbl(vValue), 8
      Case conFieldTypeCurrency
        CopyMemory bytArr(0), CCur(vValue), 8
      Case conFieldTypeInteger
        CopyMemory bytArr(0), CInt(vValue), 2
      Case conFieldTypeSingle
        CopyMemory bytArr(0), CSng(vValue), 4
      Case conFieldTypeByte
        bytArr(0) = CByte(vValue)
     End Select
    Else
     If IsNull(vValue) Then
        ReDim bytArr(0 To .Size - 1)
     Else
        MsgBox "   !", vbExclamation
     End If
    End If
   Case conFieldTypeDateTime
        Call SetDateTime(vValue, bytArr)
   Case conFieldTypeVariant
        Call SetDecimal(vValue, bytArr)
  End Select
 
  If UBound(bytArr) >= .Size Then
    MsgBox " " & vValue & "  !" & vbCrLf _
        & vbCrLf & "  - " & .Size & " .", vbExclamation
    Exit Property
  End If
    CopyMemory BuffData(.Offset), bytArr(0), .Size
 End With
 
SetFieldValue_exit:
    Exit Property
SetFieldValue_err:
    MsgBox Err.Description, vbCritical
    Resume SetFieldValue_exit
End Property

Private Function GetString(bytArr() As Byte) As Variant
Dim s As String, i As Long
   
 If bytArr(0) = 0 Then
        GetString = Null
        Exit Function
 End If
 Select Case lngCharset
  Case xDBFCharsetANSI
        s = StrConv(bytArr(), vbUnicode)
  Case xDBFCharsetUkrStandard
        s = ConvDOStoANSI(bytArr(), fUkrStandard:=True)
  Case Else
        s = ConvDOStoANSI(bytArr())
 End Select
 If Head.Type = xDBFType_ImpExpSpec Then
        i = InStr(1, s, vbNullChar)
  If i > 0 Then s = Left$(s, i - 1)
        GetString = RTrim$(s)
        Exit Function
 Else
        s = RTrim$(s)
  If Len(s) = 0 Then
        GetString = Null
  Else
        GetString = s
  End If
 End If
End Function

Private Function GetDate(bytArr() As Byte) As Variant
Dim intYear As Integer, intMonth As Integer, intDay As Integer
Dim i As Long, v As Integer
 For i = 0 To 7
    v = bytArr(i) - 48
  Select Case v
   Case 0 To 9
   Case Else
        GetDate = Null
        Exit Function
  End Select
  Select Case i
   Case 0: intYear = v * 1000
   Case 1: intYear = intYear + v * 100
   Case 2: intYear = intYear + v * 10
   Case 3: intYear = intYear + v
   Case 4: intMonth = v * 10
   Case 5: intMonth = intMonth + v
   Case 6: intDay = v * 10
   Case 7: intDay = intDay + v
  End Select
 Next i
    GetDate = DateSerial(intYear, intMonth, intDay)
End Function

Private Function GetNumeric(bytArr() As Byte) As Variant
Dim s As String

        s = StrConv(bytArr(), vbUnicode)
 If IsNumeric(s) Then
        GetNumeric = Val(s)
 Else
        GetNumeric = Null
 End If
End Function

Private Function GetLong(bytArr() As Byte) As Long
Dim Ret As Long
    CopyMemory Ret, bytArr(0), 4
    GetLong = Ret
End Function

Private Function GetInteger(bytArr() As Byte) As Integer
Dim Ret As Integer
    CopyMemory Ret, bytArr(0), 2
    GetInteger = Ret
End Function

Private Function GetSingle(bytArr() As Byte) As Single
Dim Ret As Single
    CopyMemory Ret, bytArr(0), 4
    GetSingle = Ret
End Function

Private Function GetSpecialInteger(bytArr() As Byte, _
                Optional fLittleEndianFormat As Boolean, _
                Optional lngStartPos As Long, _
                Optional lngLen As Long = 4) As Long
'      .
'    ,   lngLen
' ()  lngStartPos ( )    4 .
'   4-  -   , 
'  .  .   2-  (&HFFFF)=65535,
'   -1   Integer.
'  fLittleEndianFormat -     .
Dim i As Long, j As Long, l As Long, U As Long
Dim bytArrTemp(0 To 3) As Byte, lngRet As Long

    l = LBound(bytArr) + lngStartPos
 If l > UBound(bytArr) Then Exit Function
 Select Case lngLen
  Case 1 To 3
    U = l + lngLen - 1
  Case Else
    U = l + 3
 End Select
 If U > UBound(bytArr) Then U = UBound(bytArr)
 
 For i = l To U
  If fLittleEndianFormat Then
    j = U - i
  Else
    j = i - l
  End If
    bytArrTemp(j) = bytArr(i)
 Next i
    CopyMemory lngRet, bytArrTemp(0), 4&
    GetSpecialInteger = lngRet
End Function

Private Function GetDouble(bytArr() As Byte) As Double
Dim Ret As Double
    
    CopyMemory Ret, bytArr(0), 8
    GetDouble = Ret
End Function

Private Function GetCurrency(bytArr() As Byte) As Double
Dim Ret As Currency
    
    CopyMemory Ret, bytArr(0), 8
    GetCurrency = Ret
End Function

Private Function GetDecimal(bytArr() As Byte) As Variant
Dim Ret As Variant
    
    CopyMemory Ret, bytArr(0), 16
    GetDecimal = Ret
End Function

Private Function GetDateTime(bytArr() As Byte) As Variant
Dim Ret As Long, dblDateValue As Double, datDate As Date
    
 If Head.Type = xDBFType_ImpExpSpec Then
    CopyMemory dblDateValue, bytArr(0), 8
 Else
    CopyMemory Ret, bytArr(0), 4
    dblDateValue = Ret - conDateOffset
    CopyMemory Ret, bytArr(4), 4
    dblDateValue = dblDateValue + Ret / 86400000
 End If
 If dblDateValue = 0 Then
    GetDateTime = Null
 Else
    GetDateTime = CDate(dblDateValue)
 End If
End Function

Private Function GetMemo(bytAddress() As Byte, _
                    Optional lngMemoChunkSize As Long, _
                    Optional fBinary As Boolean, _
                    Optional fGetSize As Boolean) As Variant
On Error GoTo GetMemo_err
Dim lngPageSize As Long
Dim bytArr() As Byte
Dim lngAddress As Long, lngStart As Long, lngLen As Long
Static lngPrevAddress As Long, lngPrevLen As Long, _
    lngOffsetChunk As Long

    GetMemo = Null
 Select Case Head.Type
  Case xDBFType_FoxPro30, xDBFType_ImpExpSpec
' Visual FoxPro    4-   Long.
    lngAddress = GetLong(bytAddress)
  Case Else
'      10-   Numeric.
    lngAddress = CLng(Nz(GetNumeric(bytAddress), 0))
 End Select
 If lngAddress < 1 Then
'         - .
    lngPrevAddress = 0
    lngPrevLen = 0
    lngOffsetChunk = 0
    Exit Function
 ElseIf lngAddress <> lngPrevAddress Then
    lngPrevAddress = 0
    lngPrevLen = 0
    lngOffsetChunk = 0
 ElseIf lngOffsetChunk < 0 Then
  If lngMemoChunkSize > 0 Then
'    .
    Exit Function
  Else
    lngOffsetChunk = 0
  End If
 End If
 If Len(strMemoFullPath) = 0 Then Exit Function
 If hMemoFile = 0 Then
'MEMO     .
    hMemoFile = FreeFile
    Open strMemoFullPath For Binary Access Read Write As hMemoFile
 End If
 Select Case Head.Type
  Case xDBFType_dBASE_III     'FoxBASE+/dBASE III PLUS, with memo
        lngPageSize = 512
        lngStart = lngAddress * lngPageSize + 1
   If lngAddress = lngPrevAddress And lngPrevLen > 0 Then
        lngLen = lngPrevLen
   Else
        lngLen = CheckMemoLenDBASEIII(hMemoFile, lngStart)
        lngPrevLen = lngLen
   End If
  
  Case xDBFType_dBASE_IV_V    'dBASE IV with memo
        lngPageSize = 512
        lngStart = lngAddress * lngPageSize + 1
'  8  .
        ReDim bytArr(0 To 7)
        Get hMemoFile, lngStart, bytArr
'  0-3 .   FF FF 08 00.
   If GetSpecialInteger(bytArr) <> &H8FFFF Then GoTo GetMemo_exit
' 3-7    ,   8 .
        lngLen = GetSpecialInteger(bytArr, , 3)
'   8- ,    
' .
        lngStart = lngStart + 8
        lngLen = lngLen - 8
  
  Case Else   'FoxPro 2.x, FoxPro 3.0, ImpExpSpec
'   4  (4-7) ,   
'  (  -  ).
        ReDim bytArr(0 To 3)
        Get hMemoFile, 5, bytArr
        lngPageSize = GetSpecialInteger(bytArr, True)
        lngStart = lngAddress * lngPageSize + 1
        ReDim bytArr(0 To 7)
        Get hMemoFile, lngStart, bytArr()
        fBinary = (bytArr(3) = 0)
        lngLen = GetSpecialInteger(bytArr, True, 4)
        lngStart = lngStart + 8
 End Select
        
        lngPrevAddress = lngAddress
 
 If fGetSize Then
    GetMemo = lngLen
    GoTo GetMemo_exit
 End If
 
 If lngMemoChunkSize > 0 Then
        lngStart = lngStart + lngOffsetChunk
  If lngOffsetChunk + lngMemoChunkSize >= lngLen Then
        lngLen = lngLen - lngOffsetChunk
        lngOffsetChunk = -1
  Else
        lngLen = lngMemoChunkSize
        lngOffsetChunk = lngOffsetChunk + lngMemoChunkSize
  End If
 End If
 If lngLen <= 0 Then GoTo GetMemo_exit
        
        ReDim bytArr(0 To lngLen - 1)
        Get hMemoFile, lngStart, bytArr()
 
 If fBinary Then
        GetMemo = bytArr()
 Else
        GetMemo = GetString(bytArr)
 End If
 
GetMemo_exit:
    Exit Function
GetMemo_err:
    MsgBox Err.Description, vbCritical
    Resume GetMemo_exit
End Function

Public Function GetMemoDataSize(vIndex As Variant) As Long
'    MEMO   .
Dim lngFieldNum As Long, bytArr() As Byte

 If hFile = 0 And Not fNewFile Then Exit Function
 If bytRecordMode = 0 And NoRecord Then Exit Function

    lngFieldNum = CheckNumField(vIndex)
 If lngFieldNum < 0 Then Exit Function

 With DBFFieldsExt(lngFieldNum)
  Select Case DBFFieldsExt(lngFieldNum).TypeDBF
   Case conFieldTypeMemo, conFieldTypeGeneral
   Case Else: Exit Function
  End Select
  
    ReDim bytArr(0 To .Size - 1)
  If bytRecordMode = 0 Then
   If .Offset > GetArraySize(CurData) Then Exit Function
    CopyMemory bytArr(0), CurData(.Offset), .Size
  Else
   If .Offset > GetArraySize(BuffData) Then Exit Function
    CopyMemory bytArr(0), BuffData(.Offset), .Size
  End If
 End With
    GetMemoDataSize = Nz(GetMemo(bytArr, , , True), 0)
End Function

Private Function CheckMemoLenDBASEIII(hMemoFile As Integer, _
                                        lngStart As Long) As Long
'    (&H1 &H1)  DBT  DbaseIII.
'hMemoFile -   .
'lngStart -   .
On Error GoTo CheckMemoLenDBASEIII_err
Dim bytArr() As Byte, lngTemp As Long
Dim i As Long, fLastSimbolIsTerminator As Boolean
Const conPageSize = 512

    ReDim bytArr(0 To conPageSize - 1)
    lngTemp = lngStart
'        :
'     0   1 -  ;
'  2   = &H1, - ;
'    = &H1,    
'   1- .  = &H1, - ;
'    = 0,    
'   .   &H1 &H1, - .
' lngTemp   ,     , -
'     &H1.
'      ,   
' 
 Do
  If EOF(hMemoFile) Then Exit Function
        
        Get hMemoFile, lngTemp, bytArr()
  
  If fLastSimbolIsTerminator And bytArr(0) = conFileTerminator Then
        lngTemp = lngTemp + 1
        Exit Do
  End If
  Select Case bytArr(conPageSize - 1)
   Case 0, conFileTerminator
   Case Else
        GoTo NextPage
  End Select
  If bytArr(conPageSize - 1) = conFileTerminator Then
   If bytArr(conPageSize - 2) = conFileTerminator Then
        lngTemp = lngTemp + conPageSize
        Exit Do
   Else
        fLastSimbolIsTerminator = True
   End If
  End If
  For i = 0 To conPageSize - 2
   If bytArr(i) = conFileTerminator Then
    If bytArr(i + 1) = conFileTerminator Then
        lngTemp = lngTemp + i + 1
        Exit Do
    End If
   End If
  Next i
NextPage:
    lngTemp = lngTemp + conPageSize
 Loop
'  -      .
    CheckMemoLenDBASEIII = lngTemp - lngStart - 1

CheckMemoLenDBASEIII_exit:
    Exit Function
CheckMemoLenDBASEIII_err:
    Resume CheckMemoLenDBASEIII_exit
End Function

Private Function SetString(vValue As Variant, bytArr() As Byte) As Boolean
On Error Resume Next
Dim strValue As String
Dim lngLenStr As Long, lngLenArr As Long

    lngLenArr = GetArraySize(bytArr)
 If IsNull(vValue) Then
  If Head.Type = xDBFType_ImpExpSpec Then
'  ImpExpSpec   Null    - 0.
    ReDim bytArr(0 To lngLenArr - 1)
    GoTo Finish
  End If
    strValue = vbNullString
 Else
    strValue = CStr(vValue)
 End If
 If Err <> 0 Then
    Err.Clear
    strValue = vbNullString
 End If
    
    lngLenStr = Len(strValue)
 Select Case lngLenStr
  Case Is < lngLenArr
    strValue = strValue & String(lngLenArr - lngLenStr, 32)
  Case Is > lngLenArr
    MsgBox "  (" & lngLenStr & " ) " _
        & "  !" & vbCrLf & vbCrLf & " " _
        & "  " & lngLenArr & " .", vbExclamation
    strValue = Left$(strValue, lngLenArr)
 End Select
 Select Case lngCharset
  Case xDBFCharsetANSI
  Case xDBFCharsetUkrStandard
    strValue = ConvANSItoDOS(strValue, fUkrStandard:=True)
  Case Else
    strValue = ConvANSItoDOS(strValue)
 End Select
    bytArr() = StrConv(strValue, vbFromUnicode)
Finish:
    SetString = (Err = 0)
End Function

Private Function SetNumeric(vValue As Variant, bytArr() As Byte, _
            Optional bytDec As Byte) As Boolean
Dim strFormat As String, strValue As String
Dim lngLenStr As Long, lngLenArr As Long

 If bytDec > 0 Then
    strFormat = "0." & String(bytDec, 48)   '48 - "0"
 Else
    strFormat = "0"
 End If
 If IsNumeric(vValue) Then
    strValue = Format$(vValue, strFormat)
 Else
    strValue = vbNullString
 End If
    lngLenStr = Len(strValue)
    lngLenArr = GetArraySize(bytArr)
 Select Case lngLenStr
  Case Is < lngLenArr
    strValue = String(lngLenArr - lngLenStr, 32) & strValue  '32 - " "
  Case Is > lngLenArr
    MsgBox "  (" & lngLenArr & " )  " _
        & "   " & strValue & "!", vbExclamation
    Exit Function
 End Select
    bytArr() = StrConv(strValue, vbFromUnicode)
 If bytDec > 0 Then
    lngLenStr = lngLenArr - bytDec - 1
  If bytArr(lngLenStr) = 44 Then                '44 - ","
    bytArr(lngLenStr) = 46                      '46 - "."
  End If
 End If
    
    SetNumeric = True
End Function

Private Function SetDate(vValue As Variant, bytArr() As Byte) As Boolean
Dim strValue As String
 If IsDate(vValue) Then
    strValue = Format$(vValue, "YYYYMMDD")
 Else
    strValue = String$(8, 32)
 End If
    bytArr() = StrConv(strValue, vbFromUnicode)
    SetDate = True
End Function

Private Function SetDateTime(vValue As Variant, bytArr() As Byte) As Boolean
Dim dblDateValue As Double, lngDatePart As Long, lngTimePart As Long

 If IsDate(vValue) Then
    dblDateValue = CDbl(CDate(vValue))
 ElseIf IsNull(vValue) Then
    ReDim bytArr(0 To 7)
    SetDateTime = True
    Exit Function
 Else
    MsgBox "   !", vbExclamation
    Exit Function
 End If
 If Head.Type = xDBFType_ImpExpSpec Then
    CopyMemory bytArr(0), dblDateValue, 8
 Else
    lngDatePart = Int(dblDateValue)
    lngTimePart = (dblDateValue - lngDatePart) * 86400000
    lngDatePart = lngDatePart + conDateOffset
    CopyMemory bytArr(0), lngDatePart, 4
    CopyMemory bytArr(4), lngTimePart, 4
 End If
    SetDateTime = True
End Function

Private Function SetMemo(hMemo As Integer, bytAddress() As Byte, _
                    Optional vData As Variant, _
                    Optional fChunkMode As Boolean, _
                    Optional fBinary As Boolean) As Boolean
'    MEMO .
'hMemo -  .      
' ,   ,   Compact.
'bytAddress() - ,   ,  
'  .
'vData -   ,  .
'fChunkMode -  " ".
'fBinary -     .
On Error GoTo SetMemo_err
Dim lngNewAddress As Long, lngPageSize As Long
Dim bytArrData() As Byte, lngDataLen As Long, bytArrTemp() As Byte
Dim fNewFormat As Boolean, fFoxProFormat As Boolean
Dim lngAddress As Long, lngStart As Long, lngLen As Long
Static lngPrevAddress As Long, lngPrevLen As Long

 If UBound(bytAddress) = 0 Then
'      "Update".
'      .
    lngPrevAddress = 0
    lngPrevLen = 0
    Exit Function
 End If
 
 Select Case VarType(vData)
  Case vbString
        bytArrData() = StrConv(CStr(vData), vbFromUnicode)
  Case (vbArray Or vbByte)
        bytArrData() = vData
 End Select
        lngDataLen = GetArraySize(bytArrData)

 Select Case Head.Type
  Case xDBFType_FoxPro30, xDBFType_ImpExpSpec
' FoxPro 3.0  ImpExpSpec    4-   Long.
    lngAddress = GetLong(bytAddress)
    fNewFormat = True
' Long     .
    fFoxProFormat = True
  Case Else
'      10-   Numeric.
    lngAddress = CLng(Nz(GetNumeric(bytAddress), 0))
' FoxPro2x  Long     .
    fFoxProFormat = (Head.Type = xDBFType_FoxPro2x)
 End Select
'   -  .  ,   
'  (  ),      
'   -   (..   ).
 If lngDataLen = 0 Then
'  ...
  If lngAddress > 0 Then
'   ...
   If lngAddress <> lngPrevAddress Then
'      -   0,
' ..  .
    If fNewFormat Then
        Call SetSpecialInteger(0, bytAddress)
    Else
        Call SetNumeric(0, bytAddress)
    End If
   Else
'     ( ) -  
'    .
        lngPrevAddress = 0
        lngPrevLen = 0
   End If
  End If
' .
        SetMemo = True
        Exit Function
 End If

OpenMemoFile:
 If hMemo = 0 Then
'      -    
'  strMemoFullPath.
  If Len(strMemoFullPath) = 0 Then Exit Function
    hMemo = FreeFile
    Open strMemoFullPath For Binary Access Read Write As hMemo
 End If
 
CalculateAdress:
    ReDim bytArrTemp(0 To 7)
    Get hMemo, 1, bytArrTemp
    lngNewAddress = GetSpecialInteger(bytArrTemp, fFoxProFormat)
 
 If fFoxProFormat Then
'  FoxPro  ImpExp     4-7 
'  (  0).    = 0,  
' 64 .
  If lngNewAddress <> 0 Then
    lngPageSize = GetSpecialInteger(bytArrTemp, True, 4)
  End If
  If lngPageSize = 0 Then lngPageSize = 64
 Else
'     = 512 .
    lngPageSize = 512
 End If
 
 If lngNewAddress = 0 Then
' MEMO  -  .
  If fFoxProFormat Then
   If Head.Type = xDBFType_ImpExpSpec Then
    ReDim bytArrTemp(0 To lngPageSize - 1)
    lngNewAddress = 1
   Else
    ReDim bytArrTemp(0 To 512 - 1)
    lngNewAddress = 8
   End If
    bytArrTemp(3) = lngNewAddress
    bytArrTemp(7) = lngPageSize
  Else
    ReDim bytArrTemp(0 To 512 - 1)
    lngNewAddress = 1
    bytArrTemp(0) = 1
   If Head.Type = xDBFType_dBASE_IV_V Then
'   dBaseIV/V  18-21  - 02 01 00 02.
'  !!!?
    bytArrTemp(18) = 2
    bytArrTemp(19) = 1
    bytArrTemp(21) = 2
   End If
  End If
    Put hMemo, 1, bytArrTemp
    Erase bytArrTemp
'     .
    lngAddress = lngNewAddress
    GoTo AddNewRecord
 ElseIf lngAddress = 0 Then
'     -   .
    GoTo AddNewRecord
 End If
'     .
        lngStart = lngAddress * lngPageSize + 1

 If fChunkMode Then
'   .
  If (lngAddress <> lngPrevAddress) Then
'  .
        GoTo AddNewRecord
  Else
'  .
        GoTo SaveData
  End If
 End If

'===       ===
'   MEMO   xDBFType_dBASE_III 
' - ,   .   , 
'    -     .
 If Head.Type = xDBFType_dBASE_III Then
'  - dBaseIII.
'  ,  .
        lngLen = CheckMemoLenDBASEIII(hMemo, lngStart)
        ReDim bytArrTemp(0 To 1)
        bytArrTemp(1) = 2
 Else
' ,  dBaseIII.
        ReDim bytArrTemp(0 To 3)
        Get hMemo, lngStart + 4, bytArrTemp
  If fFoxProFormat Then
'  FoxPro  ImpExp     4-7 
' (  -   ).
        lngLen = GetSpecialInteger(bytArrTemp, True)
  Else
'  dBaseIV     4-7 .  
'    1- 8  .
        lngLen = GetSpecialInteger(bytArrTemp) - 8
  End If
        ReDim bytArrTemp(0 To 1)
        bytArrTemp(0) = 8
 End If
'bytArrTemp(0) - , bytArrTemp(1) - -  .
 If lngLen <> lngDataLen Then
'       -   .
        ReDim bytArrTemp(0 To (lngLen + bytArrTemp(1) - 1))
        Put hMemo, lngStart + bytArrTemp(0), bytArrTemp
 End If
'     :
'    (  ) +  
'      .
        lngLen = lngLen + bytArrTemp(0) + bytArrTemp(1)
 If lngLen Mod lngPageSize > 0 Then
        lngLen = (lngLen \ lngPageSize + 1) * lngPageSize
 End If
'    ,     -
'  .  -   .
 If (lngLen < (lngDataLen + bytArrTemp(0) + bytArrTemp(1))) Then
  If (lngAddress + lngLen / lngPageSize) = lngNewAddress Then
        GoTo SaveData
  Else
        GoTo AddNewRecord
  End If
 Else
        GoTo SaveData
 End If

'===================   ================================
AddNewRecord:
        lngAddress = lngNewAddress
        lngPrevAddress = 0
'   
        lngPrevLen = LOF(hMemo)
'     .
        lngStart = lngNewAddress * lngPageSize + 1
'   0-    
'     .
 If (lngStart - lngPrevLen) > 1 Then
        ReDim bytArrTemp(0 To (lngStart - lngPrevLen - 2))
        Put hMemo, lngPrevLen + 1, bytArrTemp
 End If
        lngPrevLen = 0
        
'=================   =============================
SaveData:
'  " "     
'    "Update"    , 
'    lngPrevLen    .
 If Head.Type = xDBFType_dBASE_III Then
'     dBASE_III.
'   1-    2-  &H1.
  If fChunkMode Then
        Put hMemo, lngStart + lngPrevLen, bytArrData
        lngPrevAddress = lngAddress
        lngPrevLen = lngPrevLen + lngDataLen
        lngLen = lngPrevLen
  Else
        Put hMemo, lngStart, bytArrData
        lngPrevAddress = 0
        lngPrevLen = 0
        lngLen = lngDataLen
  End If
        ReDim bytArrTemp(0 To 1)
        bytArrTemp(0) = conFileTerminator
        bytArrTemp(1) = conFileTerminator
        Put hMemo, , bytArrTemp
        lngLen = lngLen + 2
        GoTo CalculateNewAddress
 End If

'     .
'   9- .
 If fChunkMode Then
  If lngPrevLen = 0 Then
        Put hMemo, lngStart + 8, bytArrData
        lngLen = lngDataLen + 8
  Else
        Put hMemo, lngStart + lngPrevLen, bytArrData
        lngLen = lngDataLen + lngPrevLen
  End If
        lngPrevLen = lngLen
        lngPrevAddress = lngAddress
 Else
        Put hMemo, lngStart + 8, bytArrData
        lngLen = lngDataLen + 8
        lngPrevLen = 0
        lngPrevAddress = 0
 End If

SaveDataLen:
'    0-3,     4-7 .
        ReDim bytArrTemp(0 To 7)
 If fFoxProFormat Then
'  FoxPro  ImpExp   -   .
        Call SetSpecialInteger(lngLen - 8, bytArrTemp, True, 4)
  If Not fBinary Then
' FoxPro 3-  = 1,   ,  0,  .
        bytArrTemp(3) = 1
  End If
 Else
'  dBaseIV/V    8  .
        Call SetSpecialInteger(lngLen, bytArrTemp, , 4)
' 0-3   FF FF 08 00.
'  !!!?
        bytArrTemp(0) = &HFF
        bytArrTemp(1) = &HFF
        bytArrTemp(2) = 8
 End If
        Put hMemo, lngStart, bytArrTemp

CalculateNewAddress:
'      (0-3 )  
' () .
'    lngStart  lngLen .
 If lngLen Mod lngPageSize > 0 Then
        lngLen = (lngLen \ lngPageSize + 1) * lngPageSize
 End If
        lngNewAddress = (lngStart - 1 + lngLen) \ lngPageSize
 If fFoxProFormat Then
        ReDim bytArrTemp(0 To 3)
        Call SetSpecialInteger(lngNewAddress, bytArrTemp, True)
        Put hMemo, 1, bytArrTemp
 Else
        Put hMemo, 1, lngNewAddress
 End If

ReturnAddress:
 If fNewFormat Then
    Call SetSpecialInteger(lngAddress, bytAddress)
 Else
    Call SetNumeric(lngAddress, bytAddress)
 End If
    SetMemo = True
    
SetMemo_exit:
    Exit Function
SetMemo_err:
    MsgBox Err.Description, vbCritical
    Resume SetMemo_exit
End Function

Private Sub SetSpecialInteger(lngValue As Long, bytArr() As Byte, _
                Optional fLittleEndianFormat As Boolean, _
                Optional lngStartPos As Long, _
                Optional ByVal bytLen As Byte)
'     .
'    ,   bytLen
' ()  lngStartPos ( )    4 .
'   4-  -   , 
'  .  .   2-  (&HFFFF)=65535,
'   -1   Integer.
'  fLittleEndianFormat -     .
Dim i As Long, j As Long, l As Long, U As Long
Dim bytArrTemp(0 To 3) As Byte, lngRet As Long

    l = LBound(bytArr) + lngStartPos
 If l > UBound(bytArr) Then Exit Sub
    CopyMemory bytArrTemp(0), lngValue, 4&
 Select Case bytLen
  Case 1 To 3
    U = l + bytLen - 1
  Case Else
    U = l + 3
 End Select
 If U > UBound(bytArr) Then
    U = UBound(bytArr)
 End If
 For i = l To U
  If fLittleEndianFormat Then
    j = U - i
  Else
    j = i - l
  End If
    bytArr(i) = bytArrTemp(j)
 Next i
End Sub

Private Function SetDecimal(vValue As Variant, bytArr) As Boolean
On Error Resume Next
    CopyMemory bytArr(0), vValue, 16&
 If Err = 0 Then
    SetDecimal = True
 Else
    Err.Clear
 End If
End Function

Public Sub Edit()
 If fNewFile Or NoRecord Then
    MsgBox " !", vbExclamation
    Exit Sub
 End If
 If Not AllowModify Then Exit Sub
 If Me.RecordIsDelete Then
    MsgBox " !", vbExclamation
    Exit Sub
 End If
    BuffData = CurData
    bytRecordMode = 1
End Sub

Public Sub AddNew()
Dim i As Long, bytArr() As Byte
 If fNewFile Then
  If lngFieldsCount = 0 Then
    MsgBox "   !", vbExclamation
    Exit Sub
  End If
 End If
 If Not AllowModify Then Exit Sub
 
 If Head.Type = xDBFType_ImpExpSpec Then
'  ImpExpSpec     .
    ReDim BuffData(0 To lngRecordLen - 1)
    BuffData(0) = 32 ' -   .
    GoTo Finish
 End If
'    ,  .
    BuffData = StrConv(Space(lngRecordLen), vbFromUnicode)
'      0   "F" 
'  .
 For i = 0 To lngFieldsCount - 1
  With DBFFieldsExt(i)
   Select Case .TypeDBF
    Case conFieldTypeMemo, conFieldTypeGeneral
     If .Size = 10 Then GoTo NextField
    Case conFieldTypeLogical
        BuffData(.Offset) = 70      '"F"
        GoTo NextField
    Case conFieldTypeString, conFieldTypeNumeric, conFieldTypeDate
        GoTo NextField
   End Select
        ReDim bytArr(0 To .Size - 1)
        CopyMemory BuffData(.Offset), bytArr(0), .Size
  End With
NextField:
 Next i
 
Finish:
    bytRecordMode = 2
End Sub

Public Sub Update()
Dim i As Integer
    
 Select Case bytRecordMode
  Case 1    '  
    Seek hFile, (Head.Offset + CurRec * lngRecordLen + 1)
    Put hFile, , BuffData
    CurData = BuffData
  Case 2    ' 
   If fNewFile Then
    If Not SaveNewFile Then Exit Sub
   End If
    Seek hFile, (Head.Offset + Head.RecordCount * lngRecordLen + 1)
    Put hFile, , BuffData               '  
    CurData = BuffData
    
    Put hFile, , conFileTerminator      '  
    
    LastDateUpdate = Date
    Head.RecordCount = Head.RecordCount + 1
    Put hFile, 5, Head.RecordCount  ' -   
    CurRec = Head.RecordCount - 1
 End Select
    
    bytRecordMode = 0

'    MEMO   .
    ReDim BuffData(0)
    Call SetMemo(0, BuffData)
    
    Erase BuffData
End Sub

Public Sub Delete()
 If NoRecord Then Exit Sub
 If RecordIsDelete Then Exit Sub
 If Not AllowModify Then Exit Sub
 
    Seek hFile, (Head.Offset + CurRec * lngRecordLen + 1)
    Put hFile, , conDeleteMark
    CurData(0) = conDeleteMark
End Sub

Public Sub UnDelete()
 If NoRecord Then Exit Sub
 If Not RecordIsDelete Then Exit Sub
 If Not AllowModify Then Exit Sub
 
    Seek hFile, (Head.Offset + CurRec * lngRecordLen + 1)
    Put hFile, , CByte(32)    ' 
    CurData(0) = 32
End Sub

Public Function FindFirst(vField As Variant, _
    vFindValue As Variant, Optional fNotEqv As Boolean) As Boolean
        FindFirst = FindRecord(vField, vFindValue, fNotEqv, True)
End Function
        
Public Function FindNext(vField As Variant, _
    vFindValue As Variant, Optional fNotEqv As Boolean) As Boolean
        FindNext = FindRecord(vField, vFindValue, fNotEqv)
End Function

Private Function FindRecord(vField As Variant, _
            vFindValue As Variant, _
            Optional fNotEqv As Boolean, _
            Optional fFindFirst As Boolean) As Boolean
' ,     vField  
' vFindValue (  ,   fNotEqv).
'    ,   fFindFirst), 
'  .    -  True, 
'   ,      .
Dim lngFieldNum As Long, vValue As Variant
Dim lngCurRecord As Long, fFound As Boolean

 If hFile = 0 Or fNewFile Then Exit Function
    lngFieldNum = CheckNumField(vField)
 If lngFieldNum < 0 Then Exit Function

    lngCurRecord = CurRec
    bytRecordMode = 0
 If fFindFirst Then
    MoveFirst
 Else
    MoveNext
 End If
 Do Until NoRecord
        vValue = GetFieldValue(lngFieldNum)
  If IsNull(vFindValue) Then
        fFound = IsNull(vValue)
        GoTo NextRecord
  End If
  Select Case GetFieldTypeForDAO(lngFieldNum)
   Case daoTypeBinary, daoTypeLongBinary
        Exit Function
   Case daoTypeText, daoTypeMemo
    If vValue Like vFindValue Then fFound = True
   Case daoTypeBoolean
    If IsNumeric(vFindValue) Then
     If vValue Eqv CBool(vFindValue) Then fFound = True
    End If
   Case daoTypeDate
    If IsDate(vFindValue) Then
     If vValue = vFindValue Then fFound = True
    End If
   Case Else
    If IsNumeric(vFindValue) Then
     If vValue = vFindValue Then fFound = True
    End If
  End Select
  
NextRecord:
  If fNotEqv Then fFound = Not fFound
  If fFound Then
        FindRecord = True
        Exit Function
  End If
        MoveNext
 Loop
    GoToRecord lngCurRecord
End Function

Public Function CompactDBF(Optional strFilePath As String, _
                    Optional strNewFilePath As String) As Long
On Error GoTo CompactDBF_err
Dim hNewFile As Integer, lngDelRecCount As Long
Dim fTempFile As Boolean, fSomeFile As Boolean
Dim bytArr() As Byte
Dim NewHead As DBFHeader
Dim strNewMemoPath As String, hNewMemoFile As Integer, fIsMemo As Boolean
Const conTempFileName = "Temp.dbf"

 If Len(strFilePath) = 0 Then
  If hFile = 0 Then Exit Function
    strFilePath = strDBFFullPath
    fSomeFile = True
 ElseIf StrComp(strFilePath, strDBFFullPath, vbTextCompare) = 0 Then
  If hFile = 0 Then
   If Not OpenFile(strFilePath) Then Exit Function
  End If
    fSomeFile = True
 Else
  If hFile <> 0 Then
   If MsgBox("    " & vbCrLf _
        & strDBFFullPath & "." & vbCrLf & vbCrLf _
        & "   ?", vbQuestion + vbOKCancel + _
        vbDefaultButton2, " " & strFilePath) = vbCancel Then
    Exit Function
   End If
  End If
  If Not OpenFile(strFilePath) Then Exit Function
 End If
 If Len(strNewFilePath) = 0 Then
    strNewFilePath = strFolder & conTempFileName
    fTempFile = True
 ElseIf StrComp(strFilePath, strNewFilePath, vbTextCompare) = 0 Then
    strNewFilePath = strFolder & conTempFileName
    fTempFile = True
 End If
 If CheckFileExists(strNewFilePath) Then
  If Not fTempFile Then
   If MsgBox(" " & strNewFilePath & ",    " _
    & "   , !" & vbCrLf & vbCrLf _
    & "?", vbQuestion + vbOKCancel + _
    vbDefaultButton2) = vbCancel Then
        Exit Function
   End If
  End If
    Kill strNewFilePath
 End If
    hNewFile = FreeFile
    Open strNewFilePath For Binary Access Write As hNewFile
 If Len(strMemoFullPath) > 0 Then
  Select Case Head.Type
   Case xDBFType_FoxPro2x, xDBFType_FoxPro30
        strNewMemoPath = ChangeFileExtention(strNewFilePath, "fpt")
   Case Else
        strNewMemoPath = ChangeFileExtention(strNewFilePath, "dbt")
  End Select
  If CheckFileExists(strNewMemoPath) Then
    Kill strNewMemoPath
  End If
    hNewMemoFile = FreeFile
    Open strNewMemoPath For Binary Access Read Write As hNewMemoFile
    fIsMemo = (hNewMemoFile <> 0)
 End If
    
    ReDim bytArr(0 To Head.Offset - 1)
    Get hFile, 1, bytArr()
    Put hNewFile, , bytArr()
    ReDim bytArr(0)
    
    Call MoveFirst(True)
 Do Until NoRecord
  If RecordIsDelete Then
    lngDelRecCount = lngDelRecCount + 1
  Else
   If fIsMemo Then
'  MEMO        , -
'   MEMO    .
    fIsMemo = CompactMemo(hNewMemoFile)
   End If
    Put hNewFile, , CurData
  End If
    Call MoveNext(True)
 Loop
    Put hNewFile, , conFileTerminator      '  
    
 With NewHead
    .Dat(0) = Year(Date) - 1900
    .Dat(1) = Month(Date)
    .Dat(2) = Day(Date)
    .RecordCount = Head.RecordCount - lngDelRecCount
 End With
    Put hNewFile, 2, NewHead.Dat
 If lngDelRecCount > 0 Then
    Put hNewFile, 5, NewHead.RecordCount
 End If
    Close #hNewFile
    hNewFile = 0
'--------------------------------------------------------
 If fTempFile Then
'      .
  If hNewMemoFile <> 0 Then
' MEMO  ,       ,
'   MEMO   ,  
'     BAK.
   If hMemoFile <> 0 Then Close #hMemoFile
        Close #hNewMemoFile
        hNewMemoFile = 0
   If fIsMemo And CheckFileExists(strNewMemoPath) Then
    If FileLen(strNewMemoPath) < FileLen(strMemoFullPath) Then
        FileCopy strMemoFullPath, strMemoFullPath & ".bak"
        FileCopy strNewMemoPath, strMemoFullPath
    End If
        Kill strNewMemoPath
   End If
  End If
  If lngDelRecCount = 0 Then
'        -  
' .
        Kill strNewFilePath
        Exit Function
  Else
    Close #hFile
    hFile = 0
'   ,    , 
'      BAK.
    FileCopy strDBFFullPath, strDBFFullPath & ".bak"
    FileCopy strNewFilePath, strDBFFullPath
    Kill strNewFilePath
  End If
  If fSomeFile Then
'  .
    Call OpenFile(strFilePath)
  End If
 End If
    CompactDBF = lngDelRecCount

CompactDBF_exit:
On Error Resume Next
 If hNewFile <> 0 Then Close #hNewFile
 If hNewMemoFile <> 0 Then Close #hNewMemoFile
    Exit Function
CompactDBF_err:
    MsgBox Err.Description, vbCritical
    Resume CompactDBF_exit
End Function

Private Function CompactMemo(hNewMemoFile As Integer) As Boolean
'   CompactDBF.    
' MEMO ,       
' .
Dim bytAddr() As Byte, vData As Variant, i As Long
Const conChunkSize As Long = 8192

 For i = 0 To FieldsCount - 1
  With DBFFieldsExt(i)
   Select Case .TypeDAO
    Case daoTypeMemo, daoTypeLongBinary
'   MEMO .
        ReDim bytAddr(0 To .Size - 1)
        CopyMemory bytAddr(0), CurData(.Offset), .Size
     Do
'     ,    
'   conChunkSize.
        vData = GetMemo(bytAddr, conChunkSize, True)
      If Not SetMemo(hNewMemoFile, bytAddr, vData, True, _
                                .TypeDAO = daoTypeLongBinary) Then
'    ,     .
            CompactMemo = False
            Exit Function
      End If
     Loop Until IsNull(vData)
'   MEMO .
        CopyMemory CurData(.Offset), bytAddr(0), .Size
   End Select
  End With
 Next i
        CompactMemo = True
End Function

Public Sub CloseFile()
On Error Resume Next
 If hFile <> 0 Then Close hFile
 If hMemoFile <> 0 Then Close hMemoFile
 
    hFile = 0
    hMemoFile = 0
    
    strDBFFullPath = vbNullString
    strFolder = vbNullString
    Erase CurData
    Erase BuffData
    Erase DBFFields
    Erase DBFFieldsExt
    lngFieldsCount = 0
    CurRec = 0
    Head.Type = 0
    Head.RecordCount = 0
End Sub

Public Property Get LastDateUpdate() As Date
    LastDateUpdate = DateSerial(Head.Dat(0) + 1900, _
                                            Head.Dat(1), Head.Dat(2))
End Property

Public Property Let LastDateUpdate(NewDate As Date)
 If hFile = 0 Then Exit Property
 If Not AllowModify Then Exit Property
 With Head
    .Dat(0) = Year(NewDate) - 1900
    .Dat(1) = Month(NewDate)
    .Dat(2) = Day(NewDate)
 End With
    Put hFile, 2, Head.Dat
End Property

Private Function ChangeFileExtention(strFilePath As String, _
                Optional ByVal strNewExt As String) As String
Dim bytArr() As Byte, i As Long
    
 If Len(strFilePath) = 0 Then Exit Function
 If Len(strNewExt) > 0 Then
  If Asc(strNewExt) <> 46 Then  '"."
    strNewExt = "." & strNewExt
  End If
 End If
 
    bytArr = StrConv(strFilePath, vbFromUnicode)
 For i = UBound(bytArr) To LBound(bytArr) Step -1
  If bytArr(i) = 46 Then        '"."
    Exit For
  End If
  If bytArr(i) = 92 Then        '"\"
    i = 0
    Exit For
  End If
 Next i
 If i = 0 Then
    ChangeFileExtention = strFilePath & strNewExt
 Else
    ChangeFileExtention = Left$(strFilePath, i) & strNewExt
 End If
End Function

Private Function CheckFileExists(strFilePath As String, _
            Optional strRetFolder As String) As Boolean
On Error Resume Next
Dim i As Long
    i = Len(Dir$(strFilePath))
 If Err <> 0 Then Err.Clear: Exit Function
 If i = 0 Then Exit Function
    strRetFolder = Left$(strFilePath, Len(strFilePath) - i)
    CheckFileExists = True
End Function

Private Function GetArraySize(bytAtt() As Byte) As Long
On Error Resume Next

    GetArraySize = UBound(bytAtt) - LBound(bytAtt) + 1
 If Err <> 0 Then
    Err.Clear
    GetArraySize = 0
 End If
End Function

Private Function AllowModify() As Boolean
 If fRO Then
    MsgBox "    !", vbExclamation
    Exit Function
 End If
    AllowModify = True
End Function

Public Property Get xDBFType_dBASE_III() As Long
    xDBFType_dBASE_III = &H83       'dBASE III+ with memo
End Property

Public Property Get xDBFType_dBASE_IV_V() As Long
    xDBFType_dBASE_IV_V = &H8B      'dBASE IV/V with memo
End Property

Public Property Get xDBFType_FoxPro2x() As Long
    xDBFType_FoxPro2x = &HF5        'FoxPro 2.x (or earlier) with memo
End Property

Public Property Get xDBFType_FoxPro30() As Long
    xDBFType_FoxPro30 = &H30        'FoxPro 3.x (Visual FoxPro)
End Property

Public Property Get xDBFType_ImpExpSpec() As Long
    xDBFType_ImpExpSpec = &H77      '    
End Property

Public Property Get xDBFCharsetDOS866() As Long
    xDBFCharsetDOS866 = 1           'DOS 866-  
End Property

Public Property Get xDBFCharsetANSI() As Long
    xDBFCharsetANSI = 3             ' Windows
End Property

Public Property Get xDBFCharsetUkrStandard() As Long
    xDBFCharsetUkrStandard = 2      'DOS  
End Property

Private Sub Class_Terminate()
 If hFile <> 0 Then Close hFile
 If hMemoFile <> 0 Then Close hMemoFile
End Sub

'=======    ========================
Function SpellIiCcLangInString(strText As String, _
                        Optional fCheckIi As Boolean, _
                        Optional fCheckCc As Boolean) As Long
'      (Eng - Cyr  )
'  "", "" (  fCheckIi), / "", ""
' (  fCheck).
'  ""   ,  .
' .  ChangeIiCcLangInArray.
Dim bArr() As Byte, i As Long, j As Long
  
 If Not fCheckIi Or Not fCheckCc Then Exit Function
 If Len(strText) = 0 Then Exit Function
 
    bArr = StrConv(strText, vbFromUnicode)
 For i = LBound(bArr) To UBound(bArr)
  If ChangeIiCcLangInArray(bArr, i, fCheckIi, fCheckCc) Then
        j = j + 1
  End If
 Next i
 If j > 0 Then
        strText = StrConv(bArr, vbUnicode)
 End If
        SpellIiCcLangInString = j
End Function

Private Function ConvANSItoDOS(strText, _
            Optional fUkrStandard As Boolean) As String
'   Windows  Dos.
'    866 .  
'  fUkrStandard -    .
'       .
Dim bArr() As Byte, i As Long, fIsChange As Boolean

 If Len(strText) = 0 Then Exit Function
    
'   UniCode  ANSI   .
    bArr() = StrConv(strText, vbFromUnicode)
 
 For i = LBound(bArr) To UBound(bArr)
   Select Case bArr(i)
    Case Is < 161
    Case 192 To 239 '  ""  ""
        bArr(i) = bArr(i) - 64
        fIsChange = True
    Case 240 To 255 '  ""  ""
        bArr(i) = bArr(i) - 16
        fIsChange = True
    Case 168        ' 
        bArr(i) = 240
        fIsChange = True
    Case 184        ' 
        bArr(i) = 241
        fIsChange = True
    Case 178        ' 
        bArr(i) = IIf(fUkrStandard, 246, 73)
        fIsChange = True
    Case 179        ' 
        bArr(i) = IIf(fUkrStandard, 247, 105)
        fIsChange = True
    Case 170        ' 
        bArr(i) = IIf(fUkrStandard, 244, 242)
        fIsChange = True
    Case 186        ' 
        bArr(i) = IIf(fUkrStandard, 245, 243)
        fIsChange = True
    Case 175        ' 
        bArr(i) = IIf(fUkrStandard, 248, 244)
        fIsChange = True
    Case 191        ' 
        bArr(i) = IIf(fUkrStandard, 249, 245)
        fIsChange = True
    Case 161        ' 
        bArr(i) = 246
        fIsChange = True
    Case 162        ' 
        bArr(i) = 247
        fIsChange = True
    Case 165        ' 
        bArr(i) = 242
        fIsChange = True
    Case 180        ' 
        bArr(i) = 243
        fIsChange = True
    Case 185        '
        bArr(i) = 252
        fIsChange = True
    Case 167        '
        bArr(i) = 21
        fIsChange = True
    Case 171        '
        bArr(i) = 60 '  "<"
        fIsChange = True
    Case 187        '
        bArr(i) = 62 '  ">"
        fIsChange = True
   End Select
 Next i
'   (UniCode).
 If fIsChange Then
    ConvANSItoDOS = StrConv(bArr(), vbUnicode)
 Else
    ConvANSItoDOS = strText
 End If
End Function

Private Function ConvDOStoANSI(strText As Variant, _
            Optional fUkrStandard As Boolean) As String
'   Dos  Windows.
'    866 .
'   fUkrStandard - .   .
' ""  ""  866     
'  .    -
'   /    .   -
' ,  -  .
'       .
Dim bArr() As Byte, i As Long
Dim fIsChange As Boolean, fIsIi As Boolean

' strText       .
 Select Case VarType(strText)
  Case vbString
   If Len(strText) = 0 Then Exit Function
'   UniCode  OEM   .
    bArr() = StrConv(strText, vbFromUnicode)
  Case (vbArray Or vbByte)
    bArr() = strText
  Case Else
    Exit Function
 End Select
 For i = LBound(bArr) To UBound(bArr)
   Select Case bArr(i)
    Case 21                 '
        bArr(i) = 167
        fIsChange = True
    Case 73, 105            ' ,i (.  .)
     If Not fUkrStandard Then fIsIi = True
    Case Is < 128
    Case 128 To 175         '  ""  ""
        bArr(i) = bArr(i) + 64
        fIsChange = True
    Case 224 To 239         '  ""  ""
        bArr(i) = bArr(i) + 16
        fIsChange = True
    Case 240                ' 
        bArr(i) = 168
        fIsChange = True
    Case 241                ' 
        bArr(i) = 184
        fIsChange = True
    Case 242                '  (. )   (866)
        bArr(i) = IIf(fUkrStandard, 165, 170)
        fIsChange = True
    Case 243                '  (. )   (866)
        bArr(i) = IIf(fUkrStandard, 180, 186)
        fIsChange = True
    Case 244                '  (. )   (866)
        bArr(i) = IIf(fUkrStandard, 170, 175)
        fIsChange = True
    Case 245                '  (. )   (866)
        bArr(i) = IIf(fUkrStandard, 186, 191)
        fIsChange = True
    Case 246                '  (. )   (866)
        bArr(i) = IIf(fUkrStandard, 178, 161)
        fIsChange = True
    Case 247                '  (. )   (866)
        bArr(i) = IIf(fUkrStandard, 179, 162)
        fIsChange = True
    Case 248                '  (. )
        bArr(i) = 175
        fIsChange = True
    Case 249                '  (. )
        bArr(i) = 191
        fIsChange = True
    Case 252                '
        bArr(i) = 185
        fIsChange = True
   End Select
 Next i
 If fIsChange And fIsIi Then
  For i = LBound(bArr) To UBound(bArr)
   Select Case bArr(i)
    Case 73, 105
        Call ChangeIiCcLangInArray(bArr, i, True)
   End Select
  Next i
 End If
'   (UniCode).
 If fIsChange Or VarType(strText) <> vbString Then
    ConvDOStoANSI = StrConv(bArr(), vbUnicode)
 Else
    ConvDOStoANSI = strText
 End If
End Function

Private Function ChangeIiCcLangInArray(bArr() As Byte, _
                        lngSimbolPos As Long, _
                        Optional fCheckIi As Boolean, _
                        Optional fCheckCc As Boolean) As Boolean
'   "I","i" (  fCheckIi),
' / "C", "c" (  fCheckCc)    .
'  Eng  Cyr ( ), :
'     ;
'   -     ,   
'    ;
'  -    ,    
'    ,     ;
'  -    ,    
'    ,     ;
'        ;
'   -   True
'  "I","i"     
'    DOS(866) ,   "C", "c" -
'     -  
'  ,      ,
'   .
On Error GoTo ChangeIiCcLangInArray_err
Dim i As Long, bNewCode As Byte
Dim fNextCyr As Boolean, fNextEng As Boolean
Dim fPrevCyr As Boolean, fPrevEng As Boolean
Dim fNextIsNumber As Boolean, fPrevIsNumber As Boolean

 Select Case bArr(lngSimbolPos)
  Case 73, 105, 178, 179                '"I","i" (eng, cyr)
   If Not fCheckIi Then Exit Function
  Case 67, 99, 209, 241                 '"C","c" (eng, cyr)
   If Not fCheckCc Then Exit Function
  Case Else
        Exit Function
 End Select

 For i = lngSimbolPos + 1 To UBound(bArr)
  Select Case bArr(i)
   Case 48 To 57                                            '0-9
        fNextIsNumber = True
        Exit For
   Case 165, 168, 170, 175, 178 To 180, 184, 186, Is >= 191 'Cyr
        fNextCyr = True
   Case 65 To 90, 97 To 122                                 'Eng
        fNextEng = True
        Exit For
  End Select
 Next i
  
 If fNextCyr Or fNextEng Then
  If (i - lngSimbolPos) = 1 Then
        fPrevCyr = fNextCyr
        fPrevEng = fNextEng
        GoTo ChangeKode
  End If
 End If
 
 For i = lngSimbolPos - 1 To LBound(bArr) Step -1
  Select Case bArr(i)
   Case 48 To 57                                            '0-9
    If fNextIsNumber Then Exit Function
        fPrevIsNumber = True
        Exit For
   Case 165, 168, 170, 175, 178 To 180, 184, 186, Is >= 191 'Cyr
        fPrevCyr = True
        Exit For
   Case 65 To 90, 97 To 122                                 'Eng
        fPrevEng = True
        Exit For
  End Select
 Next i

 If fPrevCyr Or fPrevEng Then
  If ((lngSimbolPos - i) = 1) Then
        fNextCyr = fPrevCyr
        fNextEng = fPrevEng
  ElseIf Not fNextCyr And Not fNextEng And Not fNextIsNumber _
                                        And Not fPrevIsNumber Then
        fNextCyr = fPrevCyr
        fNextEng = fPrevEng
  End If
 End If

ChangeKode:
 Select Case bArr(lngSimbolPos)
  Case 73                                           '"I" eng
   If fNextCyr And fPrevCyr Then bNewCode = 178
  Case 105                                          '"i" eng
   If fNextCyr And fPrevCyr Then bNewCode = 179
  Case 178                                          '"I" cyr
   If fNextEng And fPrevEng Then bNewCode = 73
  Case 179                                          '"i" cyr
   If fNextEng And fPrevEng Then bNewCode = 105
  Case 67                                           '"C" eng
' 67, 99, 209, 241
   If fNextCyr And fPrevCyr Then bNewCode = 209
  Case 99                                           '"c" eng
   If fNextCyr And fPrevCyr Then bNewCode = 241
  Case 209                                          '"C" cyr
   If fNextEng And fPrevEng Then bNewCode = 67
  Case 241                                          '"c" cyr
   If fNextEng And fPrevEng Then bNewCode = 99
 End Select
 If bNewCode > 0 Then
    bArr(lngSimbolPos) = bNewCode
    ChangeIiCcLangInArray = True
 End If

ChangeIiCcLangInArray_exit:
    Exit Function
ChangeIiCcLangInArray_err:
    Resume ChangeIiCcLangInArray_exit
End Function


